import{S as eg,i as tg,s as ng,e as o,k as r,w as u,t as p,M as og,c as a,d as n,m as l,a as s,x as h,h as c,b as i,N as C,f as Qh,G as e,g as f,y as g,q as _,o as v,B as b,v as ag,L as vf}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as M}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as A}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as F}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as _f}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function sg(ue){let w,D,x,y,P;return y=new A({props:{code:`# !pip install opencv-python transformers accelerate
from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
from diffusers.utils import load_image
import numpy as np
import torch

import cv2
from PIL import Image

# download an image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)
image = np.array(image)

# get canny image
image = cv2.Canny(image, 100, 200)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)

# load control net and stable diffusion v1-5
controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)

# speed up diffusion process with faster scheduler and memory optimization
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
# remove following line if xformers is not installed
pipe.enable_xformers_memory_efficient_attention()

pipe.enable_model_cpu_offload()

# generate image
generator = torch.manual_seed(0)
image = pipe(
    "futuristic-looking woman", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># !pip install opencv-python transformers accelerate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> cv2
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># download an image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.array(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = cv2.Canny(image, <span class="hljs-number">100</span>, <span class="hljs-number">200</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = image[:, :, <span class="hljs-literal">None</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = Image.fromarray(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># speed up diffusion process with faster scheduler and memory optimization</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># remove following line if xformers is not installed</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># generate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;futuristic-looking woman&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]`}}),{c(){w=o("p"),D=p("Examples:"),x=r(),u(y.$$.fragment)},l(m){w=a(m,"P",{});var E=s(w);D=c(E,"Examples:"),E.forEach(n),x=l(m),h(y.$$.fragment,m)},m(m,E){f(m,w,E),e(w,D),f(m,x,E),g(y,m,E),P=!0},p:vf,i(m){P||(_(y.$$.fragment,m),P=!0)},o(m){v(y.$$.fragment,m),P=!1},d(m){m&&n(w),m&&n(x),b(y,m)}}}function ig(ue){let w,D,x,y,P;return y=new A({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){w=o("p"),D=p("Examples:"),x=r(),u(y.$$.fragment)},l(m){w=a(m,"P",{});var E=s(w);D=c(E,"Examples:"),E.forEach(n),x=l(m),h(y.$$.fragment,m)},m(m,E){f(m,w,E),e(w,D),f(m,x,E),g(y,m,E),P=!0},p:vf,i(m){P||(_(y.$$.fragment,m),P=!0)},o(m){v(y.$$.fragment,m),P=!1},d(m){m&&n(w),m&&n(x),b(y,m)}}}function rg(ue){let w,D,x,y,P;return y=new A({props:{code:`import jax
import numpy as np
import jax.numpy as jnp
from flax.jax_utils import replicate
from flax.training.common_utils import shard
from diffusers.utils import load_image
from PIL import Image
from diffusers import FlaxStableDiffusionControlNetPipeline, FlaxControlNetModel


def image_grid(imgs, rows, cols):
    w, h = imgs[0].size
    grid = Image.new("RGB", size=(cols * w, rows * h))
    for i, img in enumerate(imgs):
        grid.paste(img, box=(i % cols * w, i // cols * h))
    return grid


def create_key(seed=0):
    return jax.random.PRNGKey(seed)


rng = create_key(0)

# get canny image
canny_image = load_image(
    "https://huggingface.co/datasets/YiYiXu/test-doc-assets/resolve/main/blog_post_cell_10_output_0.jpeg"
)

prompts = "best quality, extremely detailed"
negative_prompts = "monochrome, lowres, bad anatomy, worst quality, low quality"

# load control net and stable diffusion v1-5
controlnet, controlnet_params = FlaxControlNetModel.from_pretrained(
    "lllyasviel/sd-controlnet-canny", from_pt=True, dtype=jnp.float32
)
pipe, params = FlaxStableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, from_pt=True, dtype=jnp.float32
)
params["controlnet"] = controlnet_params

num_samples = jax.device_count()
rng = jax.random.split(rng, jax.device_count())

prompt_ids = pipe.prepare_text_inputs([prompts] * num_samples)
negative_prompt_ids = pipe.prepare_text_inputs([negative_prompts] * num_samples)
processed_image = pipe.prepare_image_inputs([canny_image] * num_samples)

p_params = replicate(params)
prompt_ids = shard(prompt_ids)
negative_prompt_ids = shard(negative_prompt_ids)
processed_image = shard(processed_image)

output = pipe(
    prompt_ids=prompt_ids,
    image=processed_image,
    params=p_params,
    prng_seed=rng,
    num_inference_steps=50,
    neg_prompt_ids=negative_prompt_ids,
    jit=True,
).images

output_images = pipe.numpy_to_pil(np.asarray(output.reshape((num_samples,) + output.shape[-3:])))
output_images = image_grid(output_images, num_samples // 4, 4)
output_images.save("generated_image.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax.numpy <span class="hljs-keyword">as</span> jnp
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionControlNetPipeline, FlaxControlNetModel


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">image_grid</span>(<span class="hljs-params">imgs, rows, cols</span>):
<span class="hljs-meta">... </span>    w, h = imgs[<span class="hljs-number">0</span>].size
<span class="hljs-meta">... </span>    grid = Image.new(<span class="hljs-string">&quot;RGB&quot;</span>, size=(cols * w, rows * h))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> i, img <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(imgs):
<span class="hljs-meta">... </span>        grid.paste(img, box=(i % cols * w, i // cols * h))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> grid


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">create_key</span>(<span class="hljs-params">seed=<span class="hljs-number">0</span></span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> jax.random.PRNGKey(seed)


<span class="hljs-meta">&gt;&gt;&gt; </span>rng = create_key(<span class="hljs-number">0</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://huggingface.co/datasets/YiYiXu/test-doc-assets/resolve/main/blog_post_cell_10_output_0.jpeg&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompts = <span class="hljs-string">&quot;best quality, extremely detailed&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompts = <span class="hljs-string">&quot;monochrome, lowres, bad anatomy, worst quality, low quality&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet, controlnet_params = FlaxControlNetModel.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, from_pt=<span class="hljs-literal">True</span>, dtype=jnp.float32
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe, params = FlaxStableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, from_pt=<span class="hljs-literal">True</span>, dtype=jnp.float32
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>params[<span class="hljs-string">&quot;controlnet&quot;</span>] = controlnet_params

<span class="hljs-meta">&gt;&gt;&gt; </span>num_samples = jax.device_count()
<span class="hljs-meta">&gt;&gt;&gt; </span>rng = jax.random.split(rng, jax.device_count())

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = pipe.prepare_text_inputs([prompts] * num_samples)
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompt_ids = pipe.prepare_text_inputs([negative_prompts] * num_samples)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_image = pipe.prepare_image_inputs([canny_image] * num_samples)

<span class="hljs-meta">&gt;&gt;&gt; </span>p_params = replicate(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = shard(prompt_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompt_ids = shard(negative_prompt_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_image = shard(processed_image)

<span class="hljs-meta">&gt;&gt;&gt; </span>output = pipe(
<span class="hljs-meta">... </span>    prompt_ids=prompt_ids,
<span class="hljs-meta">... </span>    image=processed_image,
<span class="hljs-meta">... </span>    params=p_params,
<span class="hljs-meta">... </span>    prng_seed=rng,
<span class="hljs-meta">... </span>    num_inference_steps=<span class="hljs-number">50</span>,
<span class="hljs-meta">... </span>    neg_prompt_ids=negative_prompt_ids,
<span class="hljs-meta">... </span>    jit=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span>output_images = pipe.numpy_to_pil(np.asarray(output.reshape((num_samples,) + output.shape[-<span class="hljs-number">3</span>:])))
<span class="hljs-meta">&gt;&gt;&gt; </span>output_images = image_grid(output_images, num_samples // <span class="hljs-number">4</span>, <span class="hljs-number">4</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>output_images.save(<span class="hljs-string">&quot;generated_image.png&quot;</span>)`}}),{c(){w=o("p"),D=p("Examples:"),x=r(),u(y.$$.fragment)},l(m){w=a(m,"P",{});var E=s(w);D=c(E,"Examples:"),E.forEach(n),x=l(m),h(y.$$.fragment,m)},m(m,E){f(m,w,E),e(w,D),f(m,x,E),g(y,m,E),P=!0},p:vf,i(m){P||(_(y.$$.fragment,m),P=!0)},o(m){v(y.$$.fragment,m),P=!1},d(m){m&&n(w),m&&n(x),b(y,m)}}}function lg(ue){let w,D,x,y,P,m,E,Ro,Fr,Rs,ee,he,Ho,dt,qr,Wo,Lr,Hs,ft,mt,Gr,Ur,Ws,En,Or,Vs,kn,zr,Bs,Cn,Vo,Rr,Ks,ge,Hr,ut,Wr,Vr,Ys,Pn,Br,Xs,_e,Bo,ht,Kr,Yr,Ko,gt,Xr,Zs,te,ve,Yo,_t,Zr,Xo,Jr,Js,be,Zo,ne,Jo,Qr,el,Qo,tl,nl,jn,ol,al,ea,oe,ta,vt,sl,il,na,oa,rl,ll,Dn,bt,pl,Qs,ae,ye,aa,yt,cl,sa,dl,ei,we,fl,ia,ml,ul,ti,$e,ra,la,pa,hl,gl,ca,Nn,wt,_l,Sn,vl,bl,ni,xe,yl,$t,wl,$l,oi,xt,ai,Tn,In,bf,si,V,xl,da,El,kl,An,Cl,Pl,ii,Mn,jl,ri,Et,li,Fn,Dl,pi,kt,ci,qn,Nl,di,Ct,fi,Ln,Sl,mi,Gn,Un,yf,ui,Ee,Tl,On,Il,Al,hi,Pt,gi,ke,Ml,zn,Fl,ql,_i,jt,vi,Rn,Ll,bi,Dt,yi,Hn,Gl,wi,Wn,Vn,wf,$i,Ce,fa,Ul,Ol,Bn,zl,xi,se,Pe,ma,Nt,Rl,ua,Hl,Ei,je,Wl,ha,Vl,Bl,ki,Kn,Kl,Ci,De,Yl,ga,Xl,Zl,Pi,ie,Ne,_a,St,Jl,va,Ql,ji,Yn,ep,Di,Xn,$f,Ni,Zn,tp,Si,Tt,Ti,Jn,xf,Ii,re,Se,ba,It,np,ya,op,Ai,Qn,ap,Mi,At,Ef,Fi,eo,sp,qi,Mt,Li,Ft,kf,Gi,le,Te,wa,qt,ip,$a,rp,Ui,Lt,Oi,Gt,Cf,zi,pe,Ie,xa,Ut,lp,Ea,pp,Ri,B,cp,ka,dp,fp,Ca,mp,up,Hi,Ae,hp,Ot,gp,_p,Wi,ce,Me,Pa,zt,vp,ja,bp,Vi,Fe,Da,q,Na,yp,wp,Sa,$p,xp,Ta,Ep,kp,Ia,Cp,Pp,j,L,qe,Rt,jp,Dp,Np,Aa,Sp,Tp,Ma,Ip,Ap,Fa,to,Le,Pf,Mp,qa,no,oo,jf,Fp,G,Ge,Ht,qp,Lp,Gp,La,Up,Op,Ga,zp,Rp,Ua,ao,so,Df,Hp,Oa,io,ro,Nf,Wp,U,Ue,Wt,Vp,Bp,Kp,za,Yp,Xp,Ra,Zp,Jp,Ha,lo,po,Sf,Qp,Wa,co,fo,Tf,ec,O,Oe,Vt,tc,nc,oc,Va,ac,sc,Ba,ic,rc,Ka,mo,uo,If,lc,Ya,ho,go,Af,pc,z,ze,Bt,cc,dc,fc,Xa,mc,uc,Kt,hc,Yt,gc,_c,vc,Za,_o,vo,Mf,bc,Ja,bo,yo,Ff,yc,R,Re,Xt,wc,$c,xc,Qa,Ec,kc,Zt,Cc,Jt,Pc,jc,Dc,es,wo,$o,qf,Nc,ts,xo,Eo,Lf,Sc,H,He,Qt,Tc,Ic,Ac,ns,Mc,Fc,os,qc,Lc,as,ko,Co,Gf,Gc,ss,Po,jo,Uf,Uc,W,en,tn,Oc,zc,is,Rc,Hc,nn,Wc,on,Vc,Bc,Kc,rs,Do,No,Of,Yc,ls,So,To,zf,Bi,de,We,ps,an,Xc,cs,Zc,Ki,$,sn,Jc,ds,Qc,ed,rn,td,Io,nd,od,ad,K,ln,sd,fs,id,rd,Ve,ld,Y,pn,pd,ms,cd,dd,us,fd,md,Be,cn,ud,dn,hd,hs,gd,_d,vd,X,fn,bd,gs,yd,wd,_s,$d,xd,Ke,mn,Ed,un,kd,vs,Cd,Pd,jd,S,hn,Dd,bs,Nd,Sd,ys,Td,Id,ws,Ad,Md,Ye,Fd,Xe,gn,qd,$s,Ld,Gd,Ze,_n,Ud,T,Od,xs,zd,Rd,Es,Hd,Wd,ks,Vd,Bd,Cs,Kd,Yd,Xd,Je,vn,Zd,fe,Jd,Ps,Qd,ef,js,tf,nf,Yi,me,Qe,Ds,bn,of,Ns,af,Xi,I,yn,sf,Ss,rf,lf,wn,pf,Ts,cf,df,ff,Z,$n,mf,Is,uf,hf,et,Zi;return m=new F({}),dt=new F({}),_t=new F({}),yt=new F({}),xt=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline
from diffusers.utils import load_image

# Let's load the popular vermeer image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

<span class="hljs-comment"># Let&#x27;s load the popular vermeer image</span>
image = load_image(
    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
)`}}),Et=new A({props:{code:"pip install opencv-contrib-python",highlighted:'pip <span class="hljs-keyword">install</span> opencv-contrib-python'}}),kt=new A({props:{code:"pip install diffusers transformers git+https://github.com/huggingface/accelerate.git",highlighted:'pip install diffusers transformers git+https:<span class="hljs-regexp">//gi</span>thub.com<span class="hljs-regexp">/huggingface/</span>accelerate.git'}}),Ct=new A({props:{code:`import cv2
from PIL import Image
import numpy as np

image = np.array(image)

low_threshold = 100
high_threshold = 200

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)`,highlighted:`<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

image = np.array(image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, <span class="hljs-literal">None</span>]
image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(image)`}}),Pt=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel
import torch

controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel
<span class="hljs-keyword">import</span> torch

controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)`}}),jt=new A({props:{code:`from diffusers import UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

# this command loads the individual model components on GPU on-demand.
pipe.enable_model_cpu_offload()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

<span class="hljs-comment"># this command loads the individual model components on GPU on-demand.</span>
pipe.enable_model_cpu_offload()`}}),Dt=new A({props:{code:`generator = torch.manual_seed(0)

out_image = pipe(
    "disco dancer with colorful lights", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`generator = torch.manual_seed(<span class="hljs-number">0</span>)

out_image = pipe(
    <span class="hljs-string">&quot;disco dancer with colorful lights&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
).images[<span class="hljs-number">0</span>]`}}),Nt=new F({}),St=new F({}),Tt=new A({props:{code:`from diffusers.utils import load_image
from PIL import Image
import cv2
import numpy as np
from diffusers.utils import load_image

canny_image = load_image(
    "https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png"
)
canny_image = np.array(canny_image)

low_threshold = 100
high_threshold = 200

canny_image = cv2.Canny(canny_image, low_threshold, high_threshold)

# zero out middle columns of image where pose will be overlayed
zero_start = canny_image.shape[1] // 4
zero_end = zero_start + canny_image.shape[1] // 2
canny_image[:, zero_start:zero_end] = 0

canny_image = canny_image[:, :, None]
canny_image = np.concatenate([canny_image, canny_image, canny_image], axis=2)
canny_image = Image.fromarray(canny_image)`,highlighted:`<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

canny_image = load_image(
    <span class="hljs-string">&quot;https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png&quot;</span>
)
canny_image = np.array(canny_image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

canny_image = cv2.Canny(canny_image, low_threshold, high_threshold)

<span class="hljs-comment"># zero out middle columns of image where pose will be overlayed</span>
zero_start = canny_image.shape[<span class="hljs-number">1</span>] // <span class="hljs-number">4</span>
zero_end = zero_start + canny_image.shape[<span class="hljs-number">1</span>] // <span class="hljs-number">2</span>
canny_image[:, zero_start:zero_end] = <span class="hljs-number">0</span>

canny_image = canny_image[:, :, <span class="hljs-literal">None</span>]
canny_image = np.concatenate([canny_image, canny_image, canny_image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(canny_image)`}}),It=new F({}),Mt=new A({props:{code:`from controlnet_aux import OpenposeDetector
from diffusers.utils import load_image

openpose = OpenposeDetector.from_pretrained("lllyasviel/ControlNet")

openpose_image = load_image(
    "https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png"
)
openpose_image = openpose(openpose_image)`,highlighted:`<span class="hljs-keyword">from</span> controlnet_aux <span class="hljs-keyword">import</span> OpenposeDetector
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

openpose = OpenposeDetector.from_pretrained(<span class="hljs-string">&quot;lllyasviel/ControlNet&quot;</span>)

openpose_image = load_image(
    <span class="hljs-string">&quot;https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png&quot;</span>
)
openpose_image = openpose(openpose_image)`}}),qt=new F({}),Lt=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
import torch

controlnet = [
    ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-openpose", torch_dtype=torch.float16),
    ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16),
]

pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

pipe.enable_xformers_memory_efficient_attention()
pipe.enable_model_cpu_offload()

prompt = "a giant standing in a fantasy landscape, best quality"
negative_prompt = "monochrome, lowres, bad anatomy, worst quality, low quality"

generator = torch.Generator(device="cpu").manual_seed(1)

images = [openpose_image, canny_image]

image = pipe(
    prompt,
    images,
    num_inference_steps=20,
    generator=generator,
    negative_prompt=negative_prompt,
    controlnet_conditioning_scale=[1.0, 0.8],
).images[0]

image.save("./multi_controlnet_output.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-keyword">import</span> torch

controlnet = [
    ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-openpose&quot;</span>, torch_dtype=torch.float16),
    ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16),
]

pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

pipe.enable_xformers_memory_efficient_attention()
pipe.enable_model_cpu_offload()

prompt = <span class="hljs-string">&quot;a giant standing in a fantasy landscape, best quality&quot;</span>
negative_prompt = <span class="hljs-string">&quot;monochrome, lowres, bad anatomy, worst quality, low quality&quot;</span>

generator = torch.Generator(device=<span class="hljs-string">&quot;cpu&quot;</span>).manual_seed(<span class="hljs-number">1</span>)

images = [openpose_image, canny_image]

image = pipe(
    prompt,
    images,
    num_inference_steps=<span class="hljs-number">20</span>,
    generator=generator,
    negative_prompt=negative_prompt,
    controlnet_conditioning_scale=[<span class="hljs-number">1.0</span>, <span class="hljs-number">0.8</span>],
).images[<span class="hljs-number">0</span>]

image.save(<span class="hljs-string">&quot;./multi_controlnet_output.png&quot;</span>)`}}),Ut=new F({}),zt=new F({}),an=new F({}),sn=new M({props:{name:"class diffusers.StableDiffusionControlNetPipeline",anchor:"diffusers.StableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"controlnet",val:": typing.Union[diffusers.models.controlnet.ControlNetModel, typing.List[diffusers.models.controlnet.ControlNetModel], typing.Tuple[diffusers.models.controlnet.ControlNetModel], diffusers.pipelines.stable_diffusion.pipeline_stable_diffusion_controlnet.MultiControlNetModel]"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPImageProcessor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2451/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2451/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/pr_2451/en/api/models#diffusers.ControlNetModel">ControlNetModel</a> or <code>List[ControlNetModel]</code>) &#x2014;
Provides additional conditioning to the unet during the denoising process. If you set multiple ControlNets
as a list, the outputs from each ControlNet are added together to create one combined additional
conditioning.`,name:"controlnet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2451/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/pr_2451/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/pr_2451/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/pr_2451/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPImageProcessor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L149"}}),ln=new M({props:{name:"__call__",anchor:"diffusers.StableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image, typing.List[torch.FloatTensor], typing.List[PIL.Image.Image]] = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"controlnet_conditioning_scale",val:": typing.Union[float, typing.List[float]] = 1.0"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code>, <code>PIL.Image.Image</code>, <code>List[torch.FloatTensor]</code>, <code>List[PIL.Image.Image]</code>, &#x2014;
<code>List[List[torch.FloatTensor]]</code>, or <code>List[List[PIL.Image.Image]]</code>):
The ControlNet input condition. ControlNet uses this input condition to generate guidance to Unet. If
the type is specified as <code>Torch.FloatTensor</code>, it is passed to ControlNet as is. <code>PIL.Image.Image</code> can
also be accepted as an image. The dimensions of the output image defaults to <code>image</code>&#x2019;s dimensions. If
height and/or width are passed, <code>image</code> is resized according to them. If multiple ControlNets are
specified in init, images must be passed as a list such that each element of the list can be correctly
batched for input to a single controlnet.`,name:"image"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_2451/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2451/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet. If multiple ControlNets are specified in init, you can set the
corresponding scale as a list.`,name:"controlnet_conditioning_scale"}],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L718",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2451/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2451/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),Ve=new _f({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[sg]},$$scope:{ctx:ue}}}),pn=new M({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/pipeline_utils.py#L1367"}}),cn=new M({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/pipeline_utils.py#L1383"}}),fn=new M({props:{name:"enable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L229"}}),mn=new M({props:{name:"disable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L239"}}),hn=new M({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/pipeline_utils.py#L1310"}}),Ye=new _f({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[ig]},$$scope:{ctx:ue}}}),gn=new M({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/pipeline_utils.py#L1342"}}),_n=new M({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L267"}}),vn=new M({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L246"}}),bn=new F({}),yn=new M({props:{name:"class diffusers.FlaxStableDiffusionControlNetPipeline",anchor:"diffusers.FlaxStableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": FlaxAutoencoderKL"},{name:"text_encoder",val:": FlaxCLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": FlaxUNet2DConditionModel"},{name:"controlnet",val:": FlaxControlNetModel"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim_flax.FlaxDDIMScheduler, diffusers.schedulers.scheduling_pndm_flax.FlaxPNDMScheduler, diffusers.schedulers.scheduling_lms_discrete_flax.FlaxLMSDiscreteScheduler, diffusers.schedulers.scheduling_dpmsolver_multistep_flax.FlaxDPMSolverMultistepScheduler]"},{name:"safety_checker",val:": FlaxStableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2451/en/api/models#diffusers.FlaxAutoencoderKL">FlaxAutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>FlaxCLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.FlaxCLIPTextModel" rel="nofollow">CLIP</a>,
specifically the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2451/en/api/models#diffusers.FlaxUNet2DConditionModel">FlaxUNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/pr_2451/en/api/models#diffusers.FlaxControlNetModel">FlaxControlNetModel</a> &#x2014;
Provides additional conditioning to the unet during the denoising process.`,name:"controlnet"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2451/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<code>FlaxDDIMScheduler</code>, <code>FlaxLMSDiscreteScheduler</code>, <code>FlaxPNDMScheduler</code>, or
<code>FlaxDPMSolverMultistepScheduler</code>.`,name:"scheduler"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>FlaxStableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_controlnet.py#L119"}}),$n=new M({props:{name:"__call__",anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt_ids",val:": array"},{name:"image",val:": array"},{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"prng_seed",val:": PRNGKeyArray"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": typing.Union[float, array] = 7.5"},{name:"latents",val:": array = None"},{name:"neg_prompt_ids",val:": array = None"},{name:"controlnet_conditioning_scale",val:": typing.Union[float, array] = 1.0"},{name:"return_dict",val:": bool = True"},{name:"jit",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.prompt_ids",description:`<strong>prompt_ids</strong> (<code>jnp.array</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt_ids"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>jnp.array</code>) &#x2014;
Array representing the ControlNet input condition. ControlNet use this input condition to generate
guidance to Unet.`,name:"image"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.params",description:"<strong>params</strong> (<code>Dict</code> or <code>FrozenDict</code>) &#x2014; Dictionary containing the model parameters/weights",name:"params"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.prng_seed",description:"<strong>prng_seed</strong> (<code>jax.random.KeyArray</code> or <code>jax.Array</code>) &#x2014; Array containing random number generator key",name:"prng_seed"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>jnp.array</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code> or <code>jnp.array</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet.`,name:"controlnet_conditioning_scale"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>FlaxStableDiffusionPipelineOutput</code> instead of
a plain tuple.`,name:"return_dict"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.jit",description:`<strong>jit</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to run <code>pmap</code> versions of the generation and safety scoring functions. NOTE: This argument
exists because <code>__call__</code> is not yet end-to-end pmap-able. It will be removed in a future release.`,name:"jit"}],source:"https://github.com/huggingface/diffusers/blob/vr_2451/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_controlnet.py#L357",returnDescription:`
<p><code>FlaxStableDiffusionPipelineOutput</code> if <code>return_dict</code> is True, otherwise a
<code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>FlaxStableDiffusionPipelineOutput</code> or <code>tuple</code></p>
`}}),et=new _f({props:{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[rg]},$$scope:{ctx:ue}}}),{c(){w=o("meta"),D=r(),x=o("h1"),y=o("a"),P=o("span"),u(m.$$.fragment),E=r(),Ro=o("span"),Fr=p("Text-to-Image Generation with ControlNet Conditioning"),Rs=r(),ee=o("h2"),he=o("a"),Ho=o("span"),u(dt.$$.fragment),qr=r(),Wo=o("span"),Lr=p("Overview"),Hs=r(),ft=o("p"),mt=o("a"),Gr=p("Adding Conditional Control to Text-to-Image Diffusion Models"),Ur=p(" by Lvmin Zhang and Maneesh Agrawala."),Ws=r(),En=o("p"),Or=p("Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),Vs=r(),kn=o("p"),zr=p("The abstract of the paper is the following:"),Bs=r(),Cn=o("p"),Vo=o("em"),Rr=p("We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Ks=r(),ge=o("p"),Hr=p("This model was contributed by the amazing community contributor "),ut=o("a"),Wr=p("takuma104"),Vr=p(" \u2764\uFE0F ."),Ys=r(),Pn=o("p"),Br=p("Resources:"),Xs=r(),_e=o("ul"),Bo=o("li"),ht=o("a"),Kr=p("Paper"),Yr=r(),Ko=o("li"),gt=o("a"),Xr=p("Original Code"),Zs=r(),te=o("h2"),ve=o("a"),Yo=o("span"),u(_t.$$.fragment),Zr=r(),Xo=o("span"),Jr=p("Available Pipelines:"),Js=r(),be=o("table"),Zo=o("thead"),ne=o("tr"),Jo=o("th"),Qr=p("Pipeline"),el=r(),Qo=o("th"),tl=p("Tasks"),nl=r(),jn=o("th"),ol=p("Demo"),al=r(),ea=o("tbody"),oe=o("tr"),ta=o("td"),vt=o("a"),sl=p("StableDiffusionControlNetPipeline"),il=r(),na=o("td"),oa=o("em"),rl=p("Text-to-Image Generation with ControlNet Conditioning"),ll=r(),Dn=o("td"),bt=o("a"),pl=p("Colab Example"),Qs=r(),ae=o("h2"),ye=o("a"),aa=o("span"),u(yt.$$.fragment),cl=r(),sa=o("span"),dl=p("Usage example"),ei=r(),we=o("p"),fl=p("In the following we give a simple example of how to use a "),ia=o("em"),ml=p("ControlNet"),ul=p(` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),ti=r(),$e=o("ul"),ra=o("li"),la=o("ol"),pa=o("li"),hl=p("Take an image and run it through a pre-conditioning processor."),gl=r(),ca=o("li"),Nn=o("ol"),wt=o("li"),_l=p("Run the pre-processed image through the "),Sn=o("a"),vl=p("StableDiffusionControlNetPipeline"),bl=p("."),ni=r(),xe=o("p"),yl=p("Let\u2019s have a look at a simple example using the "),$t=o("a"),wl=p("Canny Edge ControlNet"),$l=p("."),oi=r(),u(xt.$$.fragment),ai=r(),Tn=o("p"),In=o("img"),si=r(),V=o("p"),xl=p("Next, we process the image to get the canny image. This is step "),da=o("em"),El=p("1."),kl=p(" - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),An=o("a"),Cl=p("official checkpoints"),Pl=p(" for more information about other models."),ii=r(),Mn=o("p"),jl=p("First, we need to install opencv:"),ri=r(),u(Et.$$.fragment),li=r(),Fn=o("p"),Dl=p("Next, let\u2019s also install all required Hugging Face libraries:"),pi=r(),u(kt.$$.fragment),ci=r(),qn=o("p"),Nl=p("Then we can retrieve the canny edges of the image."),di=r(),u(Ct.$$.fragment),fi=r(),Ln=o("p"),Sl=p("Let\u2019s take a look at the processed image."),mi=r(),Gn=o("p"),Un=o("img"),ui=r(),Ee=o("p"),Tl=p("Now, we load the official "),On=o("a"),Il=p("Stable Diffusion 1.5 Model"),Al=p(" as well as the ControlNet for canny edges."),hi=r(),u(Pt.$$.fragment),gi=r(),ke=o("p"),Ml=p("To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),zn=o("a"),Fl=p("UniPCMultistepScheduler"),ql=p("."),_i=r(),u(jt.$$.fragment),vi=r(),Rn=o("p"),Ll=p("Finally, we can run the pipeline:"),bi=r(),u(Dt.$$.fragment),yi=r(),Hn=o("p"),Gl=p("This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),wi=r(),Wn=o("p"),Vn=o("img"),$i=r(),Ce=o("p"),fa=o("strong"),Ul=p("Note"),Ol=p(": To see how to run all other ControlNet checkpoints, please have a look at "),Bn=o("a"),zl=p("ControlNet with Stable Diffusion 1.5"),xi=r(),se=o("h2"),Pe=o("a"),ma=o("span"),u(Nt.$$.fragment),Rl=r(),ua=o("span"),Hl=p("Combining multiple conditionings"),Ei=r(),je=o("p"),Wl=p("Multiple ControlNet conditionings can be combined for a single image generation. Pass a list of ControlNets to the pipeline\u2019s constructor and a corresponding list of conditionings to "),ha=o("code"),Vl=p("__call__"),Bl=p("."),ki=r(),Kn=o("p"),Kl=p("When combining conditionings, it is helpful to mask conditionings such that they do not overlap. In the example, we mask the middle of the canny map where the pose conditioning is located."),Ci=r(),De=o("p"),Yl=p("It can also be helpful to vary the "),ga=o("code"),Xl=p("controlnet_conditioning_scales"),Zl=p(" to emphasize one conditioning over the other."),Pi=r(),ie=o("h3"),Ne=o("a"),_a=o("span"),u(St.$$.fragment),Jl=r(),va=o("span"),Ql=p("Canny conditioning"),ji=r(),Yn=o("p"),ep=p("The original image:"),Di=r(),Xn=o("img"),Ni=r(),Zn=o("p"),tp=p("Prepare the conditioning:"),Si=r(),u(Tt.$$.fragment),Ti=r(),Jn=o("img"),Ii=r(),re=o("h3"),Se=o("a"),ba=o("span"),u(It.$$.fragment),np=r(),ya=o("span"),op=p("Openpose conditioning"),Ai=r(),Qn=o("p"),ap=p("The original image:"),Mi=r(),At=o("img"),Fi=r(),eo=o("p"),sp=p("Prepare the conditioning:"),qi=r(),u(Mt.$$.fragment),Li=r(),Ft=o("img"),Gi=r(),le=o("h3"),Te=o("a"),wa=o("span"),u(qt.$$.fragment),ip=r(),$a=o("span"),rp=p("Running ControlNet with multiple conditionings"),Ui=r(),u(Lt.$$.fragment),Oi=r(),Gt=o("img"),zi=r(),pe=o("h2"),Ie=o("a"),xa=o("span"),u(Ut.$$.fragment),lp=r(),Ea=o("span"),pp=p("Available checkpoints"),Ri=r(),B=o("p"),cp=p("ControlNet requires a "),ka=o("em"),dp=p("control image"),fp=p(" in addition to the text-to-image "),Ca=o("em"),mp=p("prompt"),up=p(`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),Hi=r(),Ae=o("p"),hp=p("All checkpoints can be found under the authors\u2019 namespace "),Ot=o("a"),gp=p("lllyasviel"),_p=p("."),Wi=r(),ce=o("h3"),Me=o("a"),Pa=o("span"),u(zt.$$.fragment),vp=r(),ja=o("span"),bp=p("ControlNet with Stable Diffusion 1.5"),Vi=r(),Fe=o("table"),Da=o("thead"),q=o("tr"),Na=o("th"),yp=p("Model Name"),wp=r(),Sa=o("th"),$p=p("Control Image Overview"),xp=r(),Ta=o("th"),Ep=p("Control Image Example"),kp=r(),Ia=o("th"),Cp=p("Generated Image Example"),Pp=r(),j=o("tbody"),L=o("tr"),qe=o("td"),Rt=o("a"),jp=p("lllyasviel/sd-controlnet-canny"),Dp=o("br"),Np=r(),Aa=o("em"),Sp=p("Trained with canny edge detection"),Tp=r(),Ma=o("td"),Ip=p("A monochrome image with white edges on a black background."),Ap=r(),Fa=o("td"),to=o("a"),Le=o("img"),Mp=r(),qa=o("td"),no=o("a"),oo=o("img"),Fp=r(),G=o("tr"),Ge=o("td"),Ht=o("a"),qp=p("lllyasviel/sd-controlnet-depth"),Lp=o("br"),Gp=r(),La=o("em"),Up=p("Trained with Midas depth estimation"),Op=r(),Ga=o("td"),zp=p("A grayscale image with black representing deep areas and white representing shallow areas."),Rp=r(),Ua=o("td"),ao=o("a"),so=o("img"),Hp=r(),Oa=o("td"),io=o("a"),ro=o("img"),Wp=r(),U=o("tr"),Ue=o("td"),Wt=o("a"),Vp=p("lllyasviel/sd-controlnet-hed"),Bp=o("br"),Kp=r(),za=o("em"),Yp=p("Trained with HED edge detection (soft edge)"),Xp=r(),Ra=o("td"),Zp=p("A monochrome image with white soft edges on a black background."),Jp=r(),Ha=o("td"),lo=o("a"),po=o("img"),Qp=r(),Wa=o("td"),co=o("a"),fo=o("img"),ec=r(),O=o("tr"),Oe=o("td"),Vt=o("a"),tc=p("lllyasviel/sd-controlnet-mlsd"),nc=o("br"),oc=r(),Va=o("em"),ac=p("Trained with M-LSD line detection"),sc=r(),Ba=o("td"),ic=p("A monochrome image composed only of white straight lines on a black background."),rc=r(),Ka=o("td"),mo=o("a"),uo=o("img"),lc=r(),Ya=o("td"),ho=o("a"),go=o("img"),pc=r(),z=o("tr"),ze=o("td"),Bt=o("a"),cc=p("lllyasviel/sd-controlnet-normal"),dc=o("br"),fc=r(),Xa=o("em"),mc=p("Trained with normal map"),uc=r(),Kt=o("td"),hc=p("A "),Yt=o("a"),gc=p("normal mapped"),_c=p(" image."),vc=r(),Za=o("td"),_o=o("a"),vo=o("img"),bc=r(),Ja=o("td"),bo=o("a"),yo=o("img"),yc=r(),R=o("tr"),Re=o("td"),Xt=o("a"),wc=p("lllyasviel/sd-controlnet-openpose"),$c=o("br"),xc=r(),Qa=o("em"),Ec=p("Trained with OpenPose bone image"),kc=r(),Zt=o("td"),Cc=p("A "),Jt=o("a"),Pc=p("OpenPose bone"),jc=p(" image."),Dc=r(),es=o("td"),wo=o("a"),$o=o("img"),Nc=r(),ts=o("td"),xo=o("a"),Eo=o("img"),Sc=r(),H=o("tr"),He=o("td"),Qt=o("a"),Tc=p("lllyasviel/sd-controlnet-scribble"),Ic=o("br"),Ac=r(),ns=o("em"),Mc=p("Trained with human scribbles"),Fc=r(),os=o("td"),qc=p("A hand-drawn monochrome image with white outlines on a black background."),Lc=r(),as=o("td"),ko=o("a"),Co=o("img"),Gc=r(),ss=o("td"),Po=o("a"),jo=o("img"),Uc=r(),W=o("tr"),en=o("td"),tn=o("a"),Oc=p("lllyasviel/sd-controlnet-seg"),zc=o("br"),is=o("em"),Rc=p("Trained with semantic segmentation"),Hc=r(),nn=o("td"),Wc=p("An "),on=o("a"),Vc=p("ADE20K"),Bc=p("\u2019s segmentation protocol image."),Kc=r(),rs=o("td"),Do=o("a"),No=o("img"),Yc=r(),ls=o("td"),So=o("a"),To=o("img"),Bi=r(),de=o("h2"),We=o("a"),ps=o("span"),u(an.$$.fragment),Xc=r(),cs=o("span"),Zc=p("StableDiffusionControlNetPipeline"),Ki=r(),$=o("div"),u(sn.$$.fragment),Jc=r(),ds=o("p"),Qc=p("Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),ed=r(),rn=o("p"),td=p("This model inherits from "),Io=o("a"),nd=p("DiffusionPipeline"),od=p(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ad=r(),K=o("div"),u(ln.$$.fragment),sd=r(),fs=o("p"),id=p("Function invoked when calling the pipeline for generation."),rd=r(),u(Ve.$$.fragment),ld=r(),Y=o("div"),u(pn.$$.fragment),pd=r(),ms=o("p"),cd=p("Enable sliced attention computation."),dd=r(),us=o("p"),fd=p(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),md=r(),Be=o("div"),u(cn.$$.fragment),ud=r(),dn=o("p"),hd=p("Disable sliced attention computation. If "),hs=o("code"),gd=p("enable_attention_slicing"),_d=p(` was previously invoked, this method will go
back to computing attention in one step.`),vd=r(),X=o("div"),u(fn.$$.fragment),bd=r(),gs=o("p"),yd=p("Enable sliced VAE decoding."),wd=r(),_s=o("p"),$d=p(`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),xd=r(),Ke=o("div"),u(mn.$$.fragment),Ed=r(),un=o("p"),kd=p("Disable sliced VAE decoding. If "),vs=o("code"),Cd=p("enable_vae_slicing"),Pd=p(` was previously invoked, this method will go back to
computing decoding in one step.`),jd=r(),S=o("div"),u(hn.$$.fragment),Dd=r(),bs=o("p"),Nd=p("Enable memory efficient attention as implemented in xformers."),Sd=r(),ys=o("p"),Td=p(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Id=r(),ws=o("p"),Ad=p(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Md=r(),u(Ye.$$.fragment),Fd=r(),Xe=o("div"),u(gn.$$.fragment),qd=r(),$s=o("p"),Ld=p("Disable memory efficient attention as implemented in xformers."),Gd=r(),Ze=o("div"),u(_n.$$.fragment),Ud=r(),T=o("p"),Od=p(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),xs=o("code"),zd=p("enable_sequential_cpu_offload"),Rd=p(", this method moves one whole model at a time to the GPU when its "),Es=o("code"),Hd=p("forward"),Wd=p(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),ks=o("code"),Vd=p("enable_sequential_cpu_offload"),Bd=p(", but performance is much better due to the iterative execution of the "),Cs=o("code"),Kd=p("unet"),Yd=p("."),Xd=r(),Je=o("div"),u(vn.$$.fragment),Zd=r(),fe=o("p"),Jd=p(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),Ps=o("code"),Qd=p("torch.device('meta') and loaded to GPU only when their specific submodule has its "),ef=p("forward"),js=o("code"),tf=p("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),nf=p("enable_model_cpu_offload`, but performance is lower."),Yi=r(),me=o("h2"),Qe=o("a"),Ds=o("span"),u(bn.$$.fragment),of=r(),Ns=o("span"),af=p("FlaxStableDiffusionControlNetPipeline"),Xi=r(),I=o("div"),u(yn.$$.fragment),sf=r(),Ss=o("p"),rf=p("Pipeline for text-to-image generation using Stable Diffusion with ControlNet Guidance."),lf=r(),wn=o("p"),pf=p("This model inherits from "),Ts=o("code"),cf=p("FlaxDiffusionPipeline"),df=p(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ff=r(),Z=o("div"),u($n.$$.fragment),mf=r(),Is=o("p"),uf=p("Function invoked when calling the pipeline for generation."),hf=r(),u(et.$$.fragment),this.h()},l(t){const d=og('[data-svelte="svelte-1phssyn"]',document.head);w=a(d,"META",{name:!0,content:!0}),d.forEach(n),D=l(t),x=a(t,"H1",{class:!0});var xn=s(x);y=a(xn,"A",{id:!0,class:!0,href:!0});var As=s(y);P=a(As,"SPAN",{});var Ms=s(P);h(m.$$.fragment,Ms),Ms.forEach(n),As.forEach(n),E=l(xn),Ro=a(xn,"SPAN",{});var Rf=s(Ro);Fr=c(Rf,"Text-to-Image Generation with ControlNet Conditioning"),Rf.forEach(n),xn.forEach(n),Rs=l(t),ee=a(t,"H2",{class:!0});var Ji=s(ee);he=a(Ji,"A",{id:!0,class:!0,href:!0});var Hf=s(he);Ho=a(Hf,"SPAN",{});var Wf=s(Ho);h(dt.$$.fragment,Wf),Wf.forEach(n),Hf.forEach(n),qr=l(Ji),Wo=a(Ji,"SPAN",{});var Vf=s(Wo);Lr=c(Vf,"Overview"),Vf.forEach(n),Ji.forEach(n),Hs=l(t),ft=a(t,"P",{});var gf=s(ft);mt=a(gf,"A",{href:!0,rel:!0});var Bf=s(mt);Gr=c(Bf,"Adding Conditional Control to Text-to-Image Diffusion Models"),Bf.forEach(n),Ur=c(gf," by Lvmin Zhang and Maneesh Agrawala."),gf.forEach(n),Ws=l(t),En=a(t,"P",{});var Kf=s(En);Or=c(Kf,"Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),Kf.forEach(n),Vs=l(t),kn=a(t,"P",{});var Yf=s(kn);zr=c(Yf,"The abstract of the paper is the following:"),Yf.forEach(n),Bs=l(t),Cn=a(t,"P",{});var Xf=s(Cn);Vo=a(Xf,"EM",{});var Zf=s(Vo);Rr=c(Zf,"We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Zf.forEach(n),Xf.forEach(n),Ks=l(t),ge=a(t,"P",{});var Qi=s(ge);Hr=c(Qi,"This model was contributed by the amazing community contributor "),ut=a(Qi,"A",{href:!0,rel:!0});var Jf=s(ut);Wr=c(Jf,"takuma104"),Jf.forEach(n),Vr=c(Qi," \u2764\uFE0F ."),Qi.forEach(n),Ys=l(t),Pn=a(t,"P",{});var Qf=s(Pn);Br=c(Qf,"Resources:"),Qf.forEach(n),Xs=l(t),_e=a(t,"UL",{});var er=s(_e);Bo=a(er,"LI",{});var em=s(Bo);ht=a(em,"A",{href:!0,rel:!0});var tm=s(ht);Kr=c(tm,"Paper"),tm.forEach(n),em.forEach(n),Yr=l(er),Ko=a(er,"LI",{});var nm=s(Ko);gt=a(nm,"A",{href:!0,rel:!0});var om=s(gt);Xr=c(om,"Original Code"),om.forEach(n),nm.forEach(n),er.forEach(n),Zs=l(t),te=a(t,"H2",{class:!0});var tr=s(te);ve=a(tr,"A",{id:!0,class:!0,href:!0});var am=s(ve);Yo=a(am,"SPAN",{});var sm=s(Yo);h(_t.$$.fragment,sm),sm.forEach(n),am.forEach(n),Zr=l(tr),Xo=a(tr,"SPAN",{});var im=s(Xo);Jr=c(im,"Available Pipelines:"),im.forEach(n),tr.forEach(n),Js=l(t),be=a(t,"TABLE",{});var nr=s(be);Zo=a(nr,"THEAD",{});var rm=s(Zo);ne=a(rm,"TR",{});var Ao=s(ne);Jo=a(Ao,"TH",{});var lm=s(Jo);Qr=c(lm,"Pipeline"),lm.forEach(n),el=l(Ao),Qo=a(Ao,"TH",{});var pm=s(Qo);tl=c(pm,"Tasks"),pm.forEach(n),nl=l(Ao),jn=a(Ao,"TH",{align:!0});var cm=s(jn);ol=c(cm,"Demo"),cm.forEach(n),Ao.forEach(n),rm.forEach(n),al=l(nr),ea=a(nr,"TBODY",{});var dm=s(ea);oe=a(dm,"TR",{});var Mo=s(oe);ta=a(Mo,"TD",{});var fm=s(ta);vt=a(fm,"A",{href:!0,rel:!0});var mm=s(vt);sl=c(mm,"StableDiffusionControlNetPipeline"),mm.forEach(n),fm.forEach(n),il=l(Mo),na=a(Mo,"TD",{});var um=s(na);oa=a(um,"EM",{});var hm=s(oa);rl=c(hm,"Text-to-Image Generation with ControlNet Conditioning"),hm.forEach(n),um.forEach(n),ll=l(Mo),Dn=a(Mo,"TD",{align:!0});var gm=s(Dn);bt=a(gm,"A",{href:!0,rel:!0});var _m=s(bt);pl=c(_m,"Colab Example"),_m.forEach(n),gm.forEach(n),Mo.forEach(n),dm.forEach(n),nr.forEach(n),Qs=l(t),ae=a(t,"H2",{class:!0});var or=s(ae);ye=a(or,"A",{id:!0,class:!0,href:!0});var vm=s(ye);aa=a(vm,"SPAN",{});var bm=s(aa);h(yt.$$.fragment,bm),bm.forEach(n),vm.forEach(n),cl=l(or),sa=a(or,"SPAN",{});var ym=s(sa);dl=c(ym,"Usage example"),ym.forEach(n),or.forEach(n),ei=l(t),we=a(t,"P",{});var ar=s(we);fl=c(ar,"In the following we give a simple example of how to use a "),ia=a(ar,"EM",{});var wm=s(ia);ml=c(wm,"ControlNet"),wm.forEach(n),ul=c(ar,` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),ar.forEach(n),ti=l(t),$e=a(t,"UL",{});var sr=s($e);ra=a(sr,"LI",{});var $m=s(ra);la=a($m,"OL",{});var xm=s(la);pa=a(xm,"LI",{});var Em=s(pa);hl=c(Em,"Take an image and run it through a pre-conditioning processor."),Em.forEach(n),xm.forEach(n),$m.forEach(n),gl=l(sr),ca=a(sr,"LI",{});var km=s(ca);Nn=a(km,"OL",{start:!0});var Cm=s(Nn);wt=a(Cm,"LI",{});var ir=s(wt);_l=c(ir,"Run the pre-processed image through the "),Sn=a(ir,"A",{href:!0});var Pm=s(Sn);vl=c(Pm,"StableDiffusionControlNetPipeline"),Pm.forEach(n),bl=c(ir,"."),ir.forEach(n),Cm.forEach(n),km.forEach(n),sr.forEach(n),ni=l(t),xe=a(t,"P",{});var rr=s(xe);yl=c(rr,"Let\u2019s have a look at a simple example using the "),$t=a(rr,"A",{href:!0,rel:!0});var jm=s($t);wl=c(jm,"Canny Edge ControlNet"),jm.forEach(n),$l=c(rr,"."),rr.forEach(n),oi=l(t),h(xt.$$.fragment,t),ai=l(t),Tn=a(t,"P",{});var Dm=s(Tn);In=a(Dm,"IMG",{src:!0,alt:!0}),Dm.forEach(n),si=l(t),V=a(t,"P",{});var Fo=s(V);xl=c(Fo,"Next, we process the image to get the canny image. This is step "),da=a(Fo,"EM",{});var Nm=s(da);El=c(Nm,"1."),Nm.forEach(n),kl=c(Fo," - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),An=a(Fo,"A",{href:!0});var Sm=s(An);Cl=c(Sm,"official checkpoints"),Sm.forEach(n),Pl=c(Fo," for more information about other models."),Fo.forEach(n),ii=l(t),Mn=a(t,"P",{});var Tm=s(Mn);jl=c(Tm,"First, we need to install opencv:"),Tm.forEach(n),ri=l(t),h(Et.$$.fragment,t),li=l(t),Fn=a(t,"P",{});var Im=s(Fn);Dl=c(Im,"Next, let\u2019s also install all required Hugging Face libraries:"),Im.forEach(n),pi=l(t),h(kt.$$.fragment,t),ci=l(t),qn=a(t,"P",{});var Am=s(qn);Nl=c(Am,"Then we can retrieve the canny edges of the image."),Am.forEach(n),di=l(t),h(Ct.$$.fragment,t),fi=l(t),Ln=a(t,"P",{});var Mm=s(Ln);Sl=c(Mm,"Let\u2019s take a look at the processed image."),Mm.forEach(n),mi=l(t),Gn=a(t,"P",{});var Fm=s(Gn);Un=a(Fm,"IMG",{src:!0,alt:!0}),Fm.forEach(n),ui=l(t),Ee=a(t,"P",{});var lr=s(Ee);Tl=c(lr,"Now, we load the official "),On=a(lr,"A",{href:!0});var qm=s(On);Il=c(qm,"Stable Diffusion 1.5 Model"),qm.forEach(n),Al=c(lr," as well as the ControlNet for canny edges."),lr.forEach(n),hi=l(t),h(Pt.$$.fragment,t),gi=l(t),ke=a(t,"P",{});var pr=s(ke);Ml=c(pr,"To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),zn=a(pr,"A",{href:!0});var Lm=s(zn);Fl=c(Lm,"UniPCMultistepScheduler"),Lm.forEach(n),ql=c(pr,"."),pr.forEach(n),_i=l(t),h(jt.$$.fragment,t),vi=l(t),Rn=a(t,"P",{});var Gm=s(Rn);Ll=c(Gm,"Finally, we can run the pipeline:"),Gm.forEach(n),bi=l(t),h(Dt.$$.fragment,t),yi=l(t),Hn=a(t,"P",{});var Um=s(Hn);Gl=c(Um,"This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),Um.forEach(n),wi=l(t),Wn=a(t,"P",{});var Om=s(Wn);Vn=a(Om,"IMG",{src:!0,alt:!0}),Om.forEach(n),$i=l(t),Ce=a(t,"P",{});var cr=s(Ce);fa=a(cr,"STRONG",{});var zm=s(fa);Ul=c(zm,"Note"),zm.forEach(n),Ol=c(cr,": To see how to run all other ControlNet checkpoints, please have a look at "),Bn=a(cr,"A",{href:!0});var Rm=s(Bn);zl=c(Rm,"ControlNet with Stable Diffusion 1.5"),Rm.forEach(n),cr.forEach(n),xi=l(t),se=a(t,"H2",{class:!0});var dr=s(se);Pe=a(dr,"A",{id:!0,class:!0,href:!0});var Hm=s(Pe);ma=a(Hm,"SPAN",{});var Wm=s(ma);h(Nt.$$.fragment,Wm),Wm.forEach(n),Hm.forEach(n),Rl=l(dr),ua=a(dr,"SPAN",{});var Vm=s(ua);Hl=c(Vm,"Combining multiple conditionings"),Vm.forEach(n),dr.forEach(n),Ei=l(t),je=a(t,"P",{});var fr=s(je);Wl=c(fr,"Multiple ControlNet conditionings can be combined for a single image generation. Pass a list of ControlNets to the pipeline\u2019s constructor and a corresponding list of conditionings to "),ha=a(fr,"CODE",{});var Bm=s(ha);Vl=c(Bm,"__call__"),Bm.forEach(n),Bl=c(fr,"."),fr.forEach(n),ki=l(t),Kn=a(t,"P",{});var Km=s(Kn);Kl=c(Km,"When combining conditionings, it is helpful to mask conditionings such that they do not overlap. In the example, we mask the middle of the canny map where the pose conditioning is located."),Km.forEach(n),Ci=l(t),De=a(t,"P",{});var mr=s(De);Yl=c(mr,"It can also be helpful to vary the "),ga=a(mr,"CODE",{});var Ym=s(ga);Xl=c(Ym,"controlnet_conditioning_scales"),Ym.forEach(n),Zl=c(mr," to emphasize one conditioning over the other."),mr.forEach(n),Pi=l(t),ie=a(t,"H3",{class:!0});var ur=s(ie);Ne=a(ur,"A",{id:!0,class:!0,href:!0});var Xm=s(Ne);_a=a(Xm,"SPAN",{});var Zm=s(_a);h(St.$$.fragment,Zm),Zm.forEach(n),Xm.forEach(n),Jl=l(ur),va=a(ur,"SPAN",{});var Jm=s(va);Ql=c(Jm,"Canny conditioning"),Jm.forEach(n),ur.forEach(n),ji=l(t),Yn=a(t,"P",{});var Qm=s(Yn);ep=c(Qm,"The original image:"),Qm.forEach(n),Di=l(t),Xn=a(t,"IMG",{src:!0}),Ni=l(t),Zn=a(t,"P",{});var eu=s(Zn);tp=c(eu,"Prepare the conditioning:"),eu.forEach(n),Si=l(t),h(Tt.$$.fragment,t),Ti=l(t),Jn=a(t,"IMG",{src:!0}),Ii=l(t),re=a(t,"H3",{class:!0});var hr=s(re);Se=a(hr,"A",{id:!0,class:!0,href:!0});var tu=s(Se);ba=a(tu,"SPAN",{});var nu=s(ba);h(It.$$.fragment,nu),nu.forEach(n),tu.forEach(n),np=l(hr),ya=a(hr,"SPAN",{});var ou=s(ya);op=c(ou,"Openpose conditioning"),ou.forEach(n),hr.forEach(n),Ai=l(t),Qn=a(t,"P",{});var au=s(Qn);ap=c(au,"The original image:"),au.forEach(n),Mi=l(t),At=a(t,"IMG",{src:!0,width:!0}),Fi=l(t),eo=a(t,"P",{});var su=s(eo);sp=c(su,"Prepare the conditioning:"),su.forEach(n),qi=l(t),h(Mt.$$.fragment,t),Li=l(t),Ft=a(t,"IMG",{src:!0,width:!0}),Gi=l(t),le=a(t,"H3",{class:!0});var gr=s(le);Te=a(gr,"A",{id:!0,class:!0,href:!0});var iu=s(Te);wa=a(iu,"SPAN",{});var ru=s(wa);h(qt.$$.fragment,ru),ru.forEach(n),iu.forEach(n),ip=l(gr),$a=a(gr,"SPAN",{});var lu=s($a);rp=c(lu,"Running ControlNet with multiple conditionings"),lu.forEach(n),gr.forEach(n),Ui=l(t),h(Lt.$$.fragment,t),Oi=l(t),Gt=a(t,"IMG",{src:!0,width:!0}),zi=l(t),pe=a(t,"H2",{class:!0});var _r=s(pe);Ie=a(_r,"A",{id:!0,class:!0,href:!0});var pu=s(Ie);xa=a(pu,"SPAN",{});var cu=s(xa);h(Ut.$$.fragment,cu),cu.forEach(n),pu.forEach(n),lp=l(_r),Ea=a(_r,"SPAN",{});var du=s(Ea);pp=c(du,"Available checkpoints"),du.forEach(n),_r.forEach(n),Ri=l(t),B=a(t,"P",{});var qo=s(B);cp=c(qo,"ControlNet requires a "),ka=a(qo,"EM",{});var fu=s(ka);dp=c(fu,"control image"),fu.forEach(n),fp=c(qo," in addition to the text-to-image "),Ca=a(qo,"EM",{});var mu=s(Ca);mp=c(mu,"prompt"),mu.forEach(n),up=c(qo,`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),qo.forEach(n),Hi=l(t),Ae=a(t,"P",{});var vr=s(Ae);hp=c(vr,"All checkpoints can be found under the authors\u2019 namespace "),Ot=a(vr,"A",{href:!0,rel:!0});var uu=s(Ot);gp=c(uu,"lllyasviel"),uu.forEach(n),_p=c(vr,"."),vr.forEach(n),Wi=l(t),ce=a(t,"H3",{class:!0});var br=s(ce);Me=a(br,"A",{id:!0,class:!0,href:!0});var hu=s(Me);Pa=a(hu,"SPAN",{});var gu=s(Pa);h(zt.$$.fragment,gu),gu.forEach(n),hu.forEach(n),vp=l(br),ja=a(br,"SPAN",{});var _u=s(ja);bp=c(_u,"ControlNet with Stable Diffusion 1.5"),_u.forEach(n),br.forEach(n),Vi=l(t),Fe=a(t,"TABLE",{});var yr=s(Fe);Da=a(yr,"THEAD",{});var vu=s(Da);q=a(vu,"TR",{});var tt=s(q);Na=a(tt,"TH",{});var bu=s(Na);yp=c(bu,"Model Name"),bu.forEach(n),wp=l(tt),Sa=a(tt,"TH",{});var yu=s(Sa);$p=c(yu,"Control Image Overview"),yu.forEach(n),xp=l(tt),Ta=a(tt,"TH",{});var wu=s(Ta);Ep=c(wu,"Control Image Example"),wu.forEach(n),kp=l(tt),Ia=a(tt,"TH",{});var $u=s(Ia);Cp=c($u,"Generated Image Example"),$u.forEach(n),tt.forEach(n),vu.forEach(n),Pp=l(yr),j=a(yr,"TBODY",{});var N=s(j);L=a(N,"TR",{});var nt=s(L);qe=a(nt,"TD",{});var Fs=s(qe);Rt=a(Fs,"A",{href:!0,rel:!0});var xu=s(Rt);jp=c(xu,"lllyasviel/sd-controlnet-canny"),xu.forEach(n),Dp=a(Fs,"BR",{}),Np=l(Fs),Aa=a(Fs,"EM",{});var Eu=s(Aa);Sp=c(Eu,"Trained with canny edge detection"),Eu.forEach(n),Fs.forEach(n),Tp=l(nt),Ma=a(nt,"TD",{});var ku=s(Ma);Ip=c(ku,"A monochrome image with white edges on a black background."),ku.forEach(n),Ap=l(nt),Fa=a(nt,"TD",{});var Cu=s(Fa);to=a(Cu,"A",{href:!0});var Pu=s(to);Le=a(Pu,"IMG",{width:!0,style:!0,src:!0}),Pu.forEach(n),Cu.forEach(n),Mp=l(nt),qa=a(nt,"TD",{});var ju=s(qa);no=a(ju,"A",{href:!0});var Du=s(no);oo=a(Du,"IMG",{width:!0,src:!0}),Du.forEach(n),ju.forEach(n),nt.forEach(n),Fp=l(N),G=a(N,"TR",{});var ot=s(G);Ge=a(ot,"TD",{});var qs=s(Ge);Ht=a(qs,"A",{href:!0,rel:!0});var Nu=s(Ht);qp=c(Nu,"lllyasviel/sd-controlnet-depth"),Nu.forEach(n),Lp=a(qs,"BR",{}),Gp=l(qs),La=a(qs,"EM",{});var Su=s(La);Up=c(Su,"Trained with Midas depth estimation"),Su.forEach(n),qs.forEach(n),Op=l(ot),Ga=a(ot,"TD",{});var Tu=s(Ga);zp=c(Tu,"A grayscale image with black representing deep areas and white representing shallow areas."),Tu.forEach(n),Rp=l(ot),Ua=a(ot,"TD",{});var Iu=s(Ua);ao=a(Iu,"A",{href:!0});var Au=s(ao);so=a(Au,"IMG",{width:!0,src:!0}),Au.forEach(n),Iu.forEach(n),Hp=l(ot),Oa=a(ot,"TD",{});var Mu=s(Oa);io=a(Mu,"A",{href:!0});var Fu=s(io);ro=a(Fu,"IMG",{width:!0,src:!0}),Fu.forEach(n),Mu.forEach(n),ot.forEach(n),Wp=l(N),U=a(N,"TR",{});var at=s(U);Ue=a(at,"TD",{});var Ls=s(Ue);Wt=a(Ls,"A",{href:!0,rel:!0});var qu=s(Wt);Vp=c(qu,"lllyasviel/sd-controlnet-hed"),qu.forEach(n),Bp=a(Ls,"BR",{}),Kp=l(Ls),za=a(Ls,"EM",{});var Lu=s(za);Yp=c(Lu,"Trained with HED edge detection (soft edge)"),Lu.forEach(n),Ls.forEach(n),Xp=l(at),Ra=a(at,"TD",{});var Gu=s(Ra);Zp=c(Gu,"A monochrome image with white soft edges on a black background."),Gu.forEach(n),Jp=l(at),Ha=a(at,"TD",{});var Uu=s(Ha);lo=a(Uu,"A",{href:!0});var Ou=s(lo);po=a(Ou,"IMG",{width:!0,src:!0}),Ou.forEach(n),Uu.forEach(n),Qp=l(at),Wa=a(at,"TD",{});var zu=s(Wa);co=a(zu,"A",{href:!0});var Ru=s(co);fo=a(Ru,"IMG",{width:!0,src:!0}),Ru.forEach(n),zu.forEach(n),at.forEach(n),ec=l(N),O=a(N,"TR",{});var st=s(O);Oe=a(st,"TD",{});var Gs=s(Oe);Vt=a(Gs,"A",{href:!0,rel:!0});var Hu=s(Vt);tc=c(Hu,"lllyasviel/sd-controlnet-mlsd"),Hu.forEach(n),nc=a(Gs,"BR",{}),oc=l(Gs),Va=a(Gs,"EM",{});var Wu=s(Va);ac=c(Wu,"Trained with M-LSD line detection"),Wu.forEach(n),Gs.forEach(n),sc=l(st),Ba=a(st,"TD",{});var Vu=s(Ba);ic=c(Vu,"A monochrome image composed only of white straight lines on a black background."),Vu.forEach(n),rc=l(st),Ka=a(st,"TD",{});var Bu=s(Ka);mo=a(Bu,"A",{href:!0});var Ku=s(mo);uo=a(Ku,"IMG",{width:!0,src:!0}),Ku.forEach(n),Bu.forEach(n),lc=l(st),Ya=a(st,"TD",{});var Yu=s(Ya);ho=a(Yu,"A",{href:!0});var Xu=s(ho);go=a(Xu,"IMG",{width:!0,src:!0}),Xu.forEach(n),Yu.forEach(n),st.forEach(n),pc=l(N),z=a(N,"TR",{});var it=s(z);ze=a(it,"TD",{});var Us=s(ze);Bt=a(Us,"A",{href:!0,rel:!0});var Zu=s(Bt);cc=c(Zu,"lllyasviel/sd-controlnet-normal"),Zu.forEach(n),dc=a(Us,"BR",{}),fc=l(Us),Xa=a(Us,"EM",{});var Ju=s(Xa);mc=c(Ju,"Trained with normal map"),Ju.forEach(n),Us.forEach(n),uc=l(it),Kt=a(it,"TD",{});var wr=s(Kt);hc=c(wr,"A "),Yt=a(wr,"A",{href:!0,rel:!0});var Qu=s(Yt);gc=c(Qu,"normal mapped"),Qu.forEach(n),_c=c(wr," image."),wr.forEach(n),vc=l(it),Za=a(it,"TD",{});var eh=s(Za);_o=a(eh,"A",{href:!0});var th=s(_o);vo=a(th,"IMG",{width:!0,src:!0}),th.forEach(n),eh.forEach(n),bc=l(it),Ja=a(it,"TD",{});var nh=s(Ja);bo=a(nh,"A",{href:!0});var oh=s(bo);yo=a(oh,"IMG",{width:!0,src:!0}),oh.forEach(n),nh.forEach(n),it.forEach(n),yc=l(N),R=a(N,"TR",{});var rt=s(R);Re=a(rt,"TD",{});var Os=s(Re);Xt=a(Os,"A",{href:!0,rel:!0});var ah=s(Xt);wc=c(ah,"lllyasviel/sd-controlnet-openpose"),ah.forEach(n),$c=a(Os,"BR",{}),xc=l(Os),Qa=a(Os,"EM",{});var sh=s(Qa);Ec=c(sh,"Trained with OpenPose bone image"),sh.forEach(n),Os.forEach(n),kc=l(rt),Zt=a(rt,"TD",{});var $r=s(Zt);Cc=c($r,"A "),Jt=a($r,"A",{href:!0,rel:!0});var ih=s(Jt);Pc=c(ih,"OpenPose bone"),ih.forEach(n),jc=c($r," image."),$r.forEach(n),Dc=l(rt),es=a(rt,"TD",{});var rh=s(es);wo=a(rh,"A",{href:!0});var lh=s(wo);$o=a(lh,"IMG",{width:!0,src:!0}),lh.forEach(n),rh.forEach(n),Nc=l(rt),ts=a(rt,"TD",{});var ph=s(ts);xo=a(ph,"A",{href:!0});var ch=s(xo);Eo=a(ch,"IMG",{width:!0,src:!0}),ch.forEach(n),ph.forEach(n),rt.forEach(n),Sc=l(N),H=a(N,"TR",{});var lt=s(H);He=a(lt,"TD",{});var zs=s(He);Qt=a(zs,"A",{href:!0,rel:!0});var dh=s(Qt);Tc=c(dh,"lllyasviel/sd-controlnet-scribble"),dh.forEach(n),Ic=a(zs,"BR",{}),Ac=l(zs),ns=a(zs,"EM",{});var fh=s(ns);Mc=c(fh,"Trained with human scribbles"),fh.forEach(n),zs.forEach(n),Fc=l(lt),os=a(lt,"TD",{});var mh=s(os);qc=c(mh,"A hand-drawn monochrome image with white outlines on a black background."),mh.forEach(n),Lc=l(lt),as=a(lt,"TD",{});var uh=s(as);ko=a(uh,"A",{href:!0});var hh=s(ko);Co=a(hh,"IMG",{width:!0,src:!0}),hh.forEach(n),uh.forEach(n),Gc=l(lt),ss=a(lt,"TD",{});var gh=s(ss);Po=a(gh,"A",{href:!0});var _h=s(Po);jo=a(_h,"IMG",{width:!0,src:!0}),_h.forEach(n),gh.forEach(n),lt.forEach(n),Uc=l(N),W=a(N,"TR",{});var pt=s(W);en=a(pt,"TD",{});var xr=s(en);tn=a(xr,"A",{href:!0,rel:!0});var vh=s(tn);Oc=c(vh,"lllyasviel/sd-controlnet-seg"),vh.forEach(n),zc=a(xr,"BR",{}),is=a(xr,"EM",{});var bh=s(is);Rc=c(bh,"Trained with semantic segmentation"),bh.forEach(n),xr.forEach(n),Hc=l(pt),nn=a(pt,"TD",{});var Er=s(nn);Wc=c(Er,"An "),on=a(Er,"A",{href:!0,rel:!0});var yh=s(on);Vc=c(yh,"ADE20K"),yh.forEach(n),Bc=c(Er,"\u2019s segmentation protocol image."),Er.forEach(n),Kc=l(pt),rs=a(pt,"TD",{});var wh=s(rs);Do=a(wh,"A",{href:!0});var $h=s(Do);No=a($h,"IMG",{width:!0,src:!0}),$h.forEach(n),wh.forEach(n),Yc=l(pt),ls=a(pt,"TD",{});var xh=s(ls);So=a(xh,"A",{href:!0});var Eh=s(So);To=a(Eh,"IMG",{width:!0,src:!0}),Eh.forEach(n),xh.forEach(n),pt.forEach(n),N.forEach(n),yr.forEach(n),Bi=l(t),de=a(t,"H2",{class:!0});var kr=s(de);We=a(kr,"A",{id:!0,class:!0,href:!0});var kh=s(We);ps=a(kh,"SPAN",{});var Ch=s(ps);h(an.$$.fragment,Ch),Ch.forEach(n),kh.forEach(n),Xc=l(kr),cs=a(kr,"SPAN",{});var Ph=s(cs);Zc=c(Ph,"StableDiffusionControlNetPipeline"),Ph.forEach(n),kr.forEach(n),Ki=l(t),$=a(t,"DIV",{class:!0});var k=s($);h(sn.$$.fragment,k),Jc=l(k),ds=a(k,"P",{});var jh=s(ds);Qc=c(jh,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),jh.forEach(n),ed=l(k),rn=a(k,"P",{});var Cr=s(rn);td=c(Cr,"This model inherits from "),Io=a(Cr,"A",{href:!0});var Dh=s(Io);nd=c(Dh,"DiffusionPipeline"),Dh.forEach(n),od=c(Cr,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Cr.forEach(n),ad=l(k),K=a(k,"DIV",{class:!0});var Lo=s(K);h(ln.$$.fragment,Lo),sd=l(Lo),fs=a(Lo,"P",{});var Nh=s(fs);id=c(Nh,"Function invoked when calling the pipeline for generation."),Nh.forEach(n),rd=l(Lo),h(Ve.$$.fragment,Lo),Lo.forEach(n),ld=l(k),Y=a(k,"DIV",{class:!0});var Go=s(Y);h(pn.$$.fragment,Go),pd=l(Go),ms=a(Go,"P",{});var Sh=s(ms);cd=c(Sh,"Enable sliced attention computation."),Sh.forEach(n),dd=l(Go),us=a(Go,"P",{});var Th=s(us);fd=c(Th,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Th.forEach(n),Go.forEach(n),md=l(k),Be=a(k,"DIV",{class:!0});var Pr=s(Be);h(cn.$$.fragment,Pr),ud=l(Pr),dn=a(Pr,"P",{});var jr=s(dn);hd=c(jr,"Disable sliced attention computation. If "),hs=a(jr,"CODE",{});var Ih=s(hs);gd=c(Ih,"enable_attention_slicing"),Ih.forEach(n),_d=c(jr,` was previously invoked, this method will go
back to computing attention in one step.`),jr.forEach(n),Pr.forEach(n),vd=l(k),X=a(k,"DIV",{class:!0});var Uo=s(X);h(fn.$$.fragment,Uo),bd=l(Uo),gs=a(Uo,"P",{});var Ah=s(gs);yd=c(Ah,"Enable sliced VAE decoding."),Ah.forEach(n),wd=l(Uo),_s=a(Uo,"P",{});var Mh=s(_s);$d=c(Mh,`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),Mh.forEach(n),Uo.forEach(n),xd=l(k),Ke=a(k,"DIV",{class:!0});var Dr=s(Ke);h(mn.$$.fragment,Dr),Ed=l(Dr),un=a(Dr,"P",{});var Nr=s(un);kd=c(Nr,"Disable sliced VAE decoding. If "),vs=a(Nr,"CODE",{});var Fh=s(vs);Cd=c(Fh,"enable_vae_slicing"),Fh.forEach(n),Pd=c(Nr,` was previously invoked, this method will go back to
computing decoding in one step.`),Nr.forEach(n),Dr.forEach(n),jd=l(k),S=a(k,"DIV",{class:!0});var J=s(S);h(hn.$$.fragment,J),Dd=l(J),bs=a(J,"P",{});var qh=s(bs);Nd=c(qh,"Enable memory efficient attention as implemented in xformers."),qh.forEach(n),Sd=l(J),ys=a(J,"P",{});var Lh=s(ys);Td=c(Lh,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Lh.forEach(n),Id=l(J),ws=a(J,"P",{});var Gh=s(ws);Ad=c(Gh,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Gh.forEach(n),Md=l(J),h(Ye.$$.fragment,J),J.forEach(n),Fd=l(k),Xe=a(k,"DIV",{class:!0});var Sr=s(Xe);h(gn.$$.fragment,Sr),qd=l(Sr),$s=a(Sr,"P",{});var Uh=s($s);Ld=c(Uh,"Disable memory efficient attention as implemented in xformers."),Uh.forEach(n),Sr.forEach(n),Gd=l(k),Ze=a(k,"DIV",{class:!0});var Tr=s(Ze);h(_n.$$.fragment,Tr),Ud=l(Tr),T=a(Tr,"P",{});var Q=s(T);Od=c(Q,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),xs=a(Q,"CODE",{});var Oh=s(xs);zd=c(Oh,"enable_sequential_cpu_offload"),Oh.forEach(n),Rd=c(Q,", this method moves one whole model at a time to the GPU when its "),Es=a(Q,"CODE",{});var zh=s(Es);Hd=c(zh,"forward"),zh.forEach(n),Wd=c(Q,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),ks=a(Q,"CODE",{});var Rh=s(ks);Vd=c(Rh,"enable_sequential_cpu_offload"),Rh.forEach(n),Bd=c(Q,", but performance is much better due to the iterative execution of the "),Cs=a(Q,"CODE",{});var Hh=s(Cs);Kd=c(Hh,"unet"),Hh.forEach(n),Yd=c(Q,"."),Q.forEach(n),Tr.forEach(n),Xd=l(k),Je=a(k,"DIV",{class:!0});var Ir=s(Je);h(vn.$$.fragment,Ir),Zd=l(Ir),fe=a(Ir,"P",{});var Oo=s(fe);Jd=c(Oo,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),Ps=a(Oo,"CODE",{});var Wh=s(Ps);Qd=c(Wh,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),Wh.forEach(n),ef=c(Oo,"forward"),js=a(Oo,"CODE",{});var Vh=s(js);tf=c(Vh,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Vh.forEach(n),nf=c(Oo,"enable_model_cpu_offload`, but performance is lower."),Oo.forEach(n),Ir.forEach(n),k.forEach(n),Yi=l(t),me=a(t,"H2",{class:!0});var Ar=s(me);Qe=a(Ar,"A",{id:!0,class:!0,href:!0});var Bh=s(Qe);Ds=a(Bh,"SPAN",{});var Kh=s(Ds);h(bn.$$.fragment,Kh),Kh.forEach(n),Bh.forEach(n),of=l(Ar),Ns=a(Ar,"SPAN",{});var Yh=s(Ns);af=c(Yh,"FlaxStableDiffusionControlNetPipeline"),Yh.forEach(n),Ar.forEach(n),Xi=l(t),I=a(t,"DIV",{class:!0});var ct=s(I);h(yn.$$.fragment,ct),sf=l(ct),Ss=a(ct,"P",{});var Xh=s(Ss);rf=c(Xh,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet Guidance."),Xh.forEach(n),lf=l(ct),wn=a(ct,"P",{});var Mr=s(wn);pf=c(Mr,"This model inherits from "),Ts=a(Mr,"CODE",{});var Zh=s(Ts);cf=c(Zh,"FlaxDiffusionPipeline"),Zh.forEach(n),df=c(Mr,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Mr.forEach(n),ff=l(ct),Z=a(ct,"DIV",{class:!0});var zo=s(Z);h($n.$$.fragment,zo),mf=l(zo),Is=a(zo,"P",{});var Jh=s(Is);uf=c(Jh,"Function invoked when calling the pipeline for generation."),Jh.forEach(n),hf=l(zo),h(et.$$.fragment,zo),zo.forEach(n),ct.forEach(n),this.h()},h(){i(w,"name","hf:doc:metadata"),i(w,"content",JSON.stringify(pg)),i(y,"id","texttoimage-generation-with-controlnet-conditioning"),i(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(y,"href","#texttoimage-generation-with-controlnet-conditioning"),i(x,"class","relative group"),i(he,"id","overview"),i(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(he,"href","#overview"),i(ee,"class","relative group"),i(mt,"href","https://arxiv.org/abs/2302.05543"),i(mt,"rel","nofollow"),i(ut,"href","https://huggingface.co/takuma104"),i(ut,"rel","nofollow"),i(ht,"href","https://arxiv.org/abs/2302.05543"),i(ht,"rel","nofollow"),i(gt,"href","https://github.com/lllyasviel/ControlNet"),i(gt,"rel","nofollow"),i(ve,"id","available-pipelines"),i(ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(ve,"href","#available-pipelines"),i(te,"class","relative group"),i(jn,"align","center"),i(vt,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py"),i(vt,"rel","nofollow"),i(bt,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/controlnet.ipynb"),i(bt,"rel","nofollow"),i(Dn,"align","center"),i(ye,"id","usage-example"),i(ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(ye,"href","#usage-example"),i(ae,"class","relative group"),i(Sn,"href","/docs/diffusers/pr_2451/en/api/pipelines/stable_diffusion/controlnet#diffusers.StableDiffusionControlNetPipeline"),i(Nn,"start","2"),i($t,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),i($t,"rel","nofollow"),C(In.src,bf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png")||i(In,"src",bf),i(In,"alt","img"),i(An,"href","#controlnet-with-stable-diffusion-1.5"),C(Un.src,yf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_canny_edged.png")||i(Un,"src",yf),i(Un,"alt","img"),i(On,"href","runwayml/stable-diffusion-v1-5"),i(zn,"href","/docs/diffusers/pr_2451/en/api/schedulers/unipc#diffusers.UniPCMultistepScheduler"),C(Vn.src,wf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_disco_dancing.png")||i(Vn,"src",wf),i(Vn,"alt","img"),i(Bn,"href","#controlnet-with-stable-diffusion-1.5"),i(Pe,"id","combining-multiple-conditionings"),i(Pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Pe,"href","#combining-multiple-conditionings"),i(se,"class","relative group"),i(Ne,"id","canny-conditioning"),i(Ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ne,"href","#canny-conditioning"),i(ie,"class","relative group"),C(Xn.src,$f="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png")||i(Xn,"src",$f),C(Jn.src,xf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/landscape_canny_masked.png")||i(Jn,"src",xf),i(Se,"id","openpose-conditioning"),i(Se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Se,"href","#openpose-conditioning"),i(re,"class","relative group"),C(At.src,Ef="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png")||i(At,"src",Ef),i(At,"width","600"),C(Ft.src,kf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/person_pose.png")||i(Ft,"src",kf),i(Ft,"width","600"),i(Te,"id","running-controlnet-with-multiple-conditionings"),i(Te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Te,"href","#running-controlnet-with-multiple-conditionings"),i(le,"class","relative group"),C(Gt.src,Cf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/multi_controlnet_output.png")||i(Gt,"src",Cf),i(Gt,"width","600"),i(Ie,"id","available-checkpoints"),i(Ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ie,"href","#available-checkpoints"),i(pe,"class","relative group"),i(Ot,"href","https://huggingface.co/lllyasviel"),i(Ot,"rel","nofollow"),i(Me,"id","controlnet-with-stable-diffusion-15"),i(Me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Me,"href","#controlnet-with-stable-diffusion-15"),i(ce,"class","relative group"),i(Rt,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),i(Rt,"rel","nofollow"),i(Le,"width","64"),Qh(Le,"margin","0"),Qh(Le,"padding","0"),C(Le.src,Pf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_canny.png")||i(Le,"src",Pf),i(to,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_canny.png"),i(oo,"width","64"),C(oo.src,jf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png")||i(oo,"src",jf),i(no,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png"),i(Ht,"href","https://huggingface.co/lllyasviel/sd-controlnet-depth"),i(Ht,"rel","nofollow"),i(so,"width","64"),C(so.src,Df="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_depth.png")||i(so,"src",Df),i(ao,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_depth.png"),i(ro,"width","64"),C(ro.src,Nf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png")||i(ro,"src",Nf),i(io,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png"),i(Wt,"href","https://huggingface.co/lllyasviel/sd-controlnet-hed"),i(Wt,"rel","nofollow"),i(po,"width","64"),C(po.src,Sf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_hed.png")||i(po,"src",Sf),i(lo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_hed.png"),i(fo,"width","64"),C(fo.src,Tf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png")||i(fo,"src",Tf),i(co,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png"),i(Vt,"href","https://huggingface.co/lllyasviel/sd-controlnet-mlsd"),i(Vt,"rel","nofollow"),i(uo,"width","64"),C(uo.src,If="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_mlsd.png")||i(uo,"src",If),i(mo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_mlsd.png"),i(go,"width","64"),C(go.src,Af="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png")||i(go,"src",Af),i(ho,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png"),i(Bt,"href","https://huggingface.co/lllyasviel/sd-controlnet-normal"),i(Bt,"rel","nofollow"),i(Yt,"href","https://en.wikipedia.org/wiki/Normal_mapping"),i(Yt,"rel","nofollow"),i(vo,"width","64"),C(vo.src,Mf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_normal.png")||i(vo,"src",Mf),i(_o,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_normal.png"),i(yo,"width","64"),C(yo.src,Ff="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png")||i(yo,"src",Ff),i(bo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png"),i(Xt,"href","https://huggingface.co/lllyasviel/sd-controlnet_openpose"),i(Xt,"rel","nofollow"),i(Jt,"href","https://github.com/CMU-Perceptual-Computing-Lab/openpose"),i(Jt,"rel","nofollow"),i($o,"width","64"),C($o.src,qf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_openpose.png")||i($o,"src",qf),i(wo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_openpose.png"),i(Eo,"width","64"),C(Eo.src,Lf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png")||i(Eo,"src",Lf),i(xo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png"),i(Qt,"href","https://huggingface.co/lllyasviel/sd-controlnet_scribble"),i(Qt,"rel","nofollow"),i(Co,"width","64"),C(Co.src,Gf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_scribble.png")||i(Co,"src",Gf),i(ko,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_scribble.png"),i(jo,"width","64"),C(jo.src,Uf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png")||i(jo,"src",Uf),i(Po,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png"),i(tn,"href","https://huggingface.co/lllyasviel/sd-controlnet_seg"),i(tn,"rel","nofollow"),i(on,"href","https://groups.csail.mit.edu/vision/datasets/ADE20K/"),i(on,"rel","nofollow"),i(No,"width","64"),C(No.src,Of="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_seg.png")||i(No,"src",Of),i(Do,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_seg.png"),i(To,"width","64"),C(To.src,zf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png")||i(To,"src",zf),i(So,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png"),i(We,"id","diffusers.StableDiffusionControlNetPipeline"),i(We,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(We,"href","#diffusers.StableDiffusionControlNetPipeline"),i(de,"class","relative group"),i(Io,"href","/docs/diffusers/pr_2451/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),i(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Qe,"id","diffusers.FlaxStableDiffusionControlNetPipeline"),i(Qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Qe,"href","#diffusers.FlaxStableDiffusionControlNetPipeline"),i(me,"class","relative group"),i(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,d){e(document.head,w),f(t,D,d),f(t,x,d),e(x,y),e(y,P),g(m,P,null),e(x,E),e(x,Ro),e(Ro,Fr),f(t,Rs,d),f(t,ee,d),e(ee,he),e(he,Ho),g(dt,Ho,null),e(ee,qr),e(ee,Wo),e(Wo,Lr),f(t,Hs,d),f(t,ft,d),e(ft,mt),e(mt,Gr),e(ft,Ur),f(t,Ws,d),f(t,En,d),e(En,Or),f(t,Vs,d),f(t,kn,d),e(kn,zr),f(t,Bs,d),f(t,Cn,d),e(Cn,Vo),e(Vo,Rr),f(t,Ks,d),f(t,ge,d),e(ge,Hr),e(ge,ut),e(ut,Wr),e(ge,Vr),f(t,Ys,d),f(t,Pn,d),e(Pn,Br),f(t,Xs,d),f(t,_e,d),e(_e,Bo),e(Bo,ht),e(ht,Kr),e(_e,Yr),e(_e,Ko),e(Ko,gt),e(gt,Xr),f(t,Zs,d),f(t,te,d),e(te,ve),e(ve,Yo),g(_t,Yo,null),e(te,Zr),e(te,Xo),e(Xo,Jr),f(t,Js,d),f(t,be,d),e(be,Zo),e(Zo,ne),e(ne,Jo),e(Jo,Qr),e(ne,el),e(ne,Qo),e(Qo,tl),e(ne,nl),e(ne,jn),e(jn,ol),e(be,al),e(be,ea),e(ea,oe),e(oe,ta),e(ta,vt),e(vt,sl),e(oe,il),e(oe,na),e(na,oa),e(oa,rl),e(oe,ll),e(oe,Dn),e(Dn,bt),e(bt,pl),f(t,Qs,d),f(t,ae,d),e(ae,ye),e(ye,aa),g(yt,aa,null),e(ae,cl),e(ae,sa),e(sa,dl),f(t,ei,d),f(t,we,d),e(we,fl),e(we,ia),e(ia,ml),e(we,ul),f(t,ti,d),f(t,$e,d),e($e,ra),e(ra,la),e(la,pa),e(pa,hl),e($e,gl),e($e,ca),e(ca,Nn),e(Nn,wt),e(wt,_l),e(wt,Sn),e(Sn,vl),e(wt,bl),f(t,ni,d),f(t,xe,d),e(xe,yl),e(xe,$t),e($t,wl),e(xe,$l),f(t,oi,d),g(xt,t,d),f(t,ai,d),f(t,Tn,d),e(Tn,In),f(t,si,d),f(t,V,d),e(V,xl),e(V,da),e(da,El),e(V,kl),e(V,An),e(An,Cl),e(V,Pl),f(t,ii,d),f(t,Mn,d),e(Mn,jl),f(t,ri,d),g(Et,t,d),f(t,li,d),f(t,Fn,d),e(Fn,Dl),f(t,pi,d),g(kt,t,d),f(t,ci,d),f(t,qn,d),e(qn,Nl),f(t,di,d),g(Ct,t,d),f(t,fi,d),f(t,Ln,d),e(Ln,Sl),f(t,mi,d),f(t,Gn,d),e(Gn,Un),f(t,ui,d),f(t,Ee,d),e(Ee,Tl),e(Ee,On),e(On,Il),e(Ee,Al),f(t,hi,d),g(Pt,t,d),f(t,gi,d),f(t,ke,d),e(ke,Ml),e(ke,zn),e(zn,Fl),e(ke,ql),f(t,_i,d),g(jt,t,d),f(t,vi,d),f(t,Rn,d),e(Rn,Ll),f(t,bi,d),g(Dt,t,d),f(t,yi,d),f(t,Hn,d),e(Hn,Gl),f(t,wi,d),f(t,Wn,d),e(Wn,Vn),f(t,$i,d),f(t,Ce,d),e(Ce,fa),e(fa,Ul),e(Ce,Ol),e(Ce,Bn),e(Bn,zl),f(t,xi,d),f(t,se,d),e(se,Pe),e(Pe,ma),g(Nt,ma,null),e(se,Rl),e(se,ua),e(ua,Hl),f(t,Ei,d),f(t,je,d),e(je,Wl),e(je,ha),e(ha,Vl),e(je,Bl),f(t,ki,d),f(t,Kn,d),e(Kn,Kl),f(t,Ci,d),f(t,De,d),e(De,Yl),e(De,ga),e(ga,Xl),e(De,Zl),f(t,Pi,d),f(t,ie,d),e(ie,Ne),e(Ne,_a),g(St,_a,null),e(ie,Jl),e(ie,va),e(va,Ql),f(t,ji,d),f(t,Yn,d),e(Yn,ep),f(t,Di,d),f(t,Xn,d),f(t,Ni,d),f(t,Zn,d),e(Zn,tp),f(t,Si,d),g(Tt,t,d),f(t,Ti,d),f(t,Jn,d),f(t,Ii,d),f(t,re,d),e(re,Se),e(Se,ba),g(It,ba,null),e(re,np),e(re,ya),e(ya,op),f(t,Ai,d),f(t,Qn,d),e(Qn,ap),f(t,Mi,d),f(t,At,d),f(t,Fi,d),f(t,eo,d),e(eo,sp),f(t,qi,d),g(Mt,t,d),f(t,Li,d),f(t,Ft,d),f(t,Gi,d),f(t,le,d),e(le,Te),e(Te,wa),g(qt,wa,null),e(le,ip),e(le,$a),e($a,rp),f(t,Ui,d),g(Lt,t,d),f(t,Oi,d),f(t,Gt,d),f(t,zi,d),f(t,pe,d),e(pe,Ie),e(Ie,xa),g(Ut,xa,null),e(pe,lp),e(pe,Ea),e(Ea,pp),f(t,Ri,d),f(t,B,d),e(B,cp),e(B,ka),e(ka,dp),e(B,fp),e(B,Ca),e(Ca,mp),e(B,up),f(t,Hi,d),f(t,Ae,d),e(Ae,hp),e(Ae,Ot),e(Ot,gp),e(Ae,_p),f(t,Wi,d),f(t,ce,d),e(ce,Me),e(Me,Pa),g(zt,Pa,null),e(ce,vp),e(ce,ja),e(ja,bp),f(t,Vi,d),f(t,Fe,d),e(Fe,Da),e(Da,q),e(q,Na),e(Na,yp),e(q,wp),e(q,Sa),e(Sa,$p),e(q,xp),e(q,Ta),e(Ta,Ep),e(q,kp),e(q,Ia),e(Ia,Cp),e(Fe,Pp),e(Fe,j),e(j,L),e(L,qe),e(qe,Rt),e(Rt,jp),e(qe,Dp),e(qe,Np),e(qe,Aa),e(Aa,Sp),e(L,Tp),e(L,Ma),e(Ma,Ip),e(L,Ap),e(L,Fa),e(Fa,to),e(to,Le),e(L,Mp),e(L,qa),e(qa,no),e(no,oo),e(j,Fp),e(j,G),e(G,Ge),e(Ge,Ht),e(Ht,qp),e(Ge,Lp),e(Ge,Gp),e(Ge,La),e(La,Up),e(G,Op),e(G,Ga),e(Ga,zp),e(G,Rp),e(G,Ua),e(Ua,ao),e(ao,so),e(G,Hp),e(G,Oa),e(Oa,io),e(io,ro),e(j,Wp),e(j,U),e(U,Ue),e(Ue,Wt),e(Wt,Vp),e(Ue,Bp),e(Ue,Kp),e(Ue,za),e(za,Yp),e(U,Xp),e(U,Ra),e(Ra,Zp),e(U,Jp),e(U,Ha),e(Ha,lo),e(lo,po),e(U,Qp),e(U,Wa),e(Wa,co),e(co,fo),e(j,ec),e(j,O),e(O,Oe),e(Oe,Vt),e(Vt,tc),e(Oe,nc),e(Oe,oc),e(Oe,Va),e(Va,ac),e(O,sc),e(O,Ba),e(Ba,ic),e(O,rc),e(O,Ka),e(Ka,mo),e(mo,uo),e(O,lc),e(O,Ya),e(Ya,ho),e(ho,go),e(j,pc),e(j,z),e(z,ze),e(ze,Bt),e(Bt,cc),e(ze,dc),e(ze,fc),e(ze,Xa),e(Xa,mc),e(z,uc),e(z,Kt),e(Kt,hc),e(Kt,Yt),e(Yt,gc),e(Kt,_c),e(z,vc),e(z,Za),e(Za,_o),e(_o,vo),e(z,bc),e(z,Ja),e(Ja,bo),e(bo,yo),e(j,yc),e(j,R),e(R,Re),e(Re,Xt),e(Xt,wc),e(Re,$c),e(Re,xc),e(Re,Qa),e(Qa,Ec),e(R,kc),e(R,Zt),e(Zt,Cc),e(Zt,Jt),e(Jt,Pc),e(Zt,jc),e(R,Dc),e(R,es),e(es,wo),e(wo,$o),e(R,Nc),e(R,ts),e(ts,xo),e(xo,Eo),e(j,Sc),e(j,H),e(H,He),e(He,Qt),e(Qt,Tc),e(He,Ic),e(He,Ac),e(He,ns),e(ns,Mc),e(H,Fc),e(H,os),e(os,qc),e(H,Lc),e(H,as),e(as,ko),e(ko,Co),e(H,Gc),e(H,ss),e(ss,Po),e(Po,jo),e(j,Uc),e(j,W),e(W,en),e(en,tn),e(tn,Oc),e(en,zc),e(en,is),e(is,Rc),e(W,Hc),e(W,nn),e(nn,Wc),e(nn,on),e(on,Vc),e(nn,Bc),e(W,Kc),e(W,rs),e(rs,Do),e(Do,No),e(W,Yc),e(W,ls),e(ls,So),e(So,To),f(t,Bi,d),f(t,de,d),e(de,We),e(We,ps),g(an,ps,null),e(de,Xc),e(de,cs),e(cs,Zc),f(t,Ki,d),f(t,$,d),g(sn,$,null),e($,Jc),e($,ds),e(ds,Qc),e($,ed),e($,rn),e(rn,td),e(rn,Io),e(Io,nd),e(rn,od),e($,ad),e($,K),g(ln,K,null),e(K,sd),e(K,fs),e(fs,id),e(K,rd),g(Ve,K,null),e($,ld),e($,Y),g(pn,Y,null),e(Y,pd),e(Y,ms),e(ms,cd),e(Y,dd),e(Y,us),e(us,fd),e($,md),e($,Be),g(cn,Be,null),e(Be,ud),e(Be,dn),e(dn,hd),e(dn,hs),e(hs,gd),e(dn,_d),e($,vd),e($,X),g(fn,X,null),e(X,bd),e(X,gs),e(gs,yd),e(X,wd),e(X,_s),e(_s,$d),e($,xd),e($,Ke),g(mn,Ke,null),e(Ke,Ed),e(Ke,un),e(un,kd),e(un,vs),e(vs,Cd),e(un,Pd),e($,jd),e($,S),g(hn,S,null),e(S,Dd),e(S,bs),e(bs,Nd),e(S,Sd),e(S,ys),e(ys,Td),e(S,Id),e(S,ws),e(ws,Ad),e(S,Md),g(Ye,S,null),e($,Fd),e($,Xe),g(gn,Xe,null),e(Xe,qd),e(Xe,$s),e($s,Ld),e($,Gd),e($,Ze),g(_n,Ze,null),e(Ze,Ud),e(Ze,T),e(T,Od),e(T,xs),e(xs,zd),e(T,Rd),e(T,Es),e(Es,Hd),e(T,Wd),e(T,ks),e(ks,Vd),e(T,Bd),e(T,Cs),e(Cs,Kd),e(T,Yd),e($,Xd),e($,Je),g(vn,Je,null),e(Je,Zd),e(Je,fe),e(fe,Jd),e(fe,Ps),e(Ps,Qd),e(fe,ef),e(fe,js),e(js,tf),e(fe,nf),f(t,Yi,d),f(t,me,d),e(me,Qe),e(Qe,Ds),g(bn,Ds,null),e(me,of),e(me,Ns),e(Ns,af),f(t,Xi,d),f(t,I,d),g(yn,I,null),e(I,sf),e(I,Ss),e(Ss,rf),e(I,lf),e(I,wn),e(wn,pf),e(wn,Ts),e(Ts,cf),e(wn,df),e(I,ff),e(I,Z),g($n,Z,null),e(Z,mf),e(Z,Is),e(Is,uf),e(Z,hf),g(et,Z,null),Zi=!0},p(t,[d]){const xn={};d&2&&(xn.$$scope={dirty:d,ctx:t}),Ve.$set(xn);const As={};d&2&&(As.$$scope={dirty:d,ctx:t}),Ye.$set(As);const Ms={};d&2&&(Ms.$$scope={dirty:d,ctx:t}),et.$set(Ms)},i(t){Zi||(_(m.$$.fragment,t),_(dt.$$.fragment,t),_(_t.$$.fragment,t),_(yt.$$.fragment,t),_(xt.$$.fragment,t),_(Et.$$.fragment,t),_(kt.$$.fragment,t),_(Ct.$$.fragment,t),_(Pt.$$.fragment,t),_(jt.$$.fragment,t),_(Dt.$$.fragment,t),_(Nt.$$.fragment,t),_(St.$$.fragment,t),_(Tt.$$.fragment,t),_(It.$$.fragment,t),_(Mt.$$.fragment,t),_(qt.$$.fragment,t),_(Lt.$$.fragment,t),_(Ut.$$.fragment,t),_(zt.$$.fragment,t),_(an.$$.fragment,t),_(sn.$$.fragment,t),_(ln.$$.fragment,t),_(Ve.$$.fragment,t),_(pn.$$.fragment,t),_(cn.$$.fragment,t),_(fn.$$.fragment,t),_(mn.$$.fragment,t),_(hn.$$.fragment,t),_(Ye.$$.fragment,t),_(gn.$$.fragment,t),_(_n.$$.fragment,t),_(vn.$$.fragment,t),_(bn.$$.fragment,t),_(yn.$$.fragment,t),_($n.$$.fragment,t),_(et.$$.fragment,t),Zi=!0)},o(t){v(m.$$.fragment,t),v(dt.$$.fragment,t),v(_t.$$.fragment,t),v(yt.$$.fragment,t),v(xt.$$.fragment,t),v(Et.$$.fragment,t),v(kt.$$.fragment,t),v(Ct.$$.fragment,t),v(Pt.$$.fragment,t),v(jt.$$.fragment,t),v(Dt.$$.fragment,t),v(Nt.$$.fragment,t),v(St.$$.fragment,t),v(Tt.$$.fragment,t),v(It.$$.fragment,t),v(Mt.$$.fragment,t),v(qt.$$.fragment,t),v(Lt.$$.fragment,t),v(Ut.$$.fragment,t),v(zt.$$.fragment,t),v(an.$$.fragment,t),v(sn.$$.fragment,t),v(ln.$$.fragment,t),v(Ve.$$.fragment,t),v(pn.$$.fragment,t),v(cn.$$.fragment,t),v(fn.$$.fragment,t),v(mn.$$.fragment,t),v(hn.$$.fragment,t),v(Ye.$$.fragment,t),v(gn.$$.fragment,t),v(_n.$$.fragment,t),v(vn.$$.fragment,t),v(bn.$$.fragment,t),v(yn.$$.fragment,t),v($n.$$.fragment,t),v(et.$$.fragment,t),Zi=!1},d(t){n(w),t&&n(D),t&&n(x),b(m),t&&n(Rs),t&&n(ee),b(dt),t&&n(Hs),t&&n(ft),t&&n(Ws),t&&n(En),t&&n(Vs),t&&n(kn),t&&n(Bs),t&&n(Cn),t&&n(Ks),t&&n(ge),t&&n(Ys),t&&n(Pn),t&&n(Xs),t&&n(_e),t&&n(Zs),t&&n(te),b(_t),t&&n(Js),t&&n(be),t&&n(Qs),t&&n(ae),b(yt),t&&n(ei),t&&n(we),t&&n(ti),t&&n($e),t&&n(ni),t&&n(xe),t&&n(oi),b(xt,t),t&&n(ai),t&&n(Tn),t&&n(si),t&&n(V),t&&n(ii),t&&n(Mn),t&&n(ri),b(Et,t),t&&n(li),t&&n(Fn),t&&n(pi),b(kt,t),t&&n(ci),t&&n(qn),t&&n(di),b(Ct,t),t&&n(fi),t&&n(Ln),t&&n(mi),t&&n(Gn),t&&n(ui),t&&n(Ee),t&&n(hi),b(Pt,t),t&&n(gi),t&&n(ke),t&&n(_i),b(jt,t),t&&n(vi),t&&n(Rn),t&&n(bi),b(Dt,t),t&&n(yi),t&&n(Hn),t&&n(wi),t&&n(Wn),t&&n($i),t&&n(Ce),t&&n(xi),t&&n(se),b(Nt),t&&n(Ei),t&&n(je),t&&n(ki),t&&n(Kn),t&&n(Ci),t&&n(De),t&&n(Pi),t&&n(ie),b(St),t&&n(ji),t&&n(Yn),t&&n(Di),t&&n(Xn),t&&n(Ni),t&&n(Zn),t&&n(Si),b(Tt,t),t&&n(Ti),t&&n(Jn),t&&n(Ii),t&&n(re),b(It),t&&n(Ai),t&&n(Qn),t&&n(Mi),t&&n(At),t&&n(Fi),t&&n(eo),t&&n(qi),b(Mt,t),t&&n(Li),t&&n(Ft),t&&n(Gi),t&&n(le),b(qt),t&&n(Ui),b(Lt,t),t&&n(Oi),t&&n(Gt),t&&n(zi),t&&n(pe),b(Ut),t&&n(Ri),t&&n(B),t&&n(Hi),t&&n(Ae),t&&n(Wi),t&&n(ce),b(zt),t&&n(Vi),t&&n(Fe),t&&n(Bi),t&&n(de),b(an),t&&n(Ki),t&&n($),b(sn),b(ln),b(Ve),b(pn),b(cn),b(fn),b(mn),b(hn),b(Ye),b(gn),b(_n),b(vn),t&&n(Yi),t&&n(me),b(bn),t&&n(Xi),t&&n(I),b(yn),b($n),b(et)}}}const pg={local:"texttoimage-generation-with-controlnet-conditioning",sections:[{local:"overview",title:"Overview"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example"},{local:"combining-multiple-conditionings",sections:[{local:"canny-conditioning",title:"Canny conditioning"},{local:"openpose-conditioning",title:"Openpose conditioning"},{local:"running-controlnet-with-multiple-conditionings",title:"Running ControlNet with multiple conditionings"}],title:"Combining multiple conditionings"},{local:"available-checkpoints",sections:[{local:"controlnet-with-stable-diffusion-15",title:"ControlNet with Stable Diffusion 1.5"}],title:"Available checkpoints"},{local:"diffusers.StableDiffusionControlNetPipeline",title:"StableDiffusionControlNetPipeline"},{local:"diffusers.FlaxStableDiffusionControlNetPipeline",title:"FlaxStableDiffusionControlNetPipeline"}],title:"Text-to-Image Generation with ControlNet Conditioning"};function cg(ue){return ag(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class gg extends eg{constructor(w){super();tg(this,w,cg,lg,ng,{})}}export{gg as default,pg as metadata};
