import{S as Es,i as js,s as Ps,e as n,k as _,w as y,t as i,M as As,c as r,d as t,m as g,a as p,x as v,h as l,b as m,G as a,g as u,y as b,q as k,o as x,B as E,v as qs,L as Kt}from"../../chunks/vendor-hf-doc-builder.js";import{T as Ts}from"../../chunks/Tip-hf-doc-builder.js";import{I as Ce}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as K}from"../../chunks/CodeBlock-hf-doc-builder.js";import{F as xs,M as Xt}from"../../chunks/Markdown-hf-doc-builder.js";function Ds(N){let o,c;return{c(){o=n("p"),c=i("The text-to-image fine-tuning script is experimental. It\u2019s easy to overfit and run into issues like catastrophic forgetting. We recommend you explore different hyperparameters to get the best results on your dataset.")},l(s){o=r(s,"P",{});var d=p(o);c=l(d,"The text-to-image fine-tuning script is experimental. It\u2019s easy to overfit and run into issues like catastrophic forgetting. We recommend you explore different hyperparameters to get the best results on your dataset."),d.forEach(t)},m(s,d){u(s,o,d),a(o,c)},d(s){s&&t(o)}}}function Ns(N){let o,c,s,d,j,q,S,F,O,T,I,A,D;return T=new K({props:{code:`\`\`\`bash
export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export dataset_name="lambdalabs/pokemon-blip-captions"

accelerate launch --mixed_precision="fp16"  train_text_to_image.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$dataset_name \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler="constant" --lr_warmup_steps=0 \\
  --output_dir="sd-pokemon-model" `,highlighted:`\`\`\`bash
<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> dataset_name=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>

accelerate launch --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span>  train_text_to_image.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$dataset_name</span> \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> --lr_warmup_steps=0 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span> `}}),A=new K({props:{code:`
To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} [Datasets](https://huggingface.co/docs/datasets/index). You can [upload your dataset to the Hub](https://huggingface.co/docs/datasets/image_dataset#upload-dataset-to-the-hub), or you can [prepare a local folder with your files](https://huggingface.co/docs/datasets/image_dataset#imagefolder).

Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in \`TRAIN_DIR\` and where to save the model to in \`OUTPUT_DIR\`:

\`\`\`bash
export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export TRAIN_DIR="path_to_your_dataset"
export OUTPUT_DIR="path_to_save_model"

accelerate launch train_text_to_image.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --train_data_dir=$TRAIN_DIR \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --mixed_precision="fp16" \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler="constant" --lr_warmup_steps=0 \\
  --output_dir=\${OUTPUT_DIR}`,highlighted:`
<span class="hljs-keyword">To</span> finetune <span class="hljs-keyword">on</span> your own dataset, <span class="hljs-keyword">prepare</span> the dataset according <span class="hljs-keyword">to</span> the <span class="hljs-keyword">format</span> required <span class="hljs-keyword">by</span> \u{1F917} [Datasets](https://huggingface.co/docs/datasets/<span class="hljs-keyword">index</span>). You can [upload your dataset <span class="hljs-keyword">to</span> the Hub](https://huggingface.co/docs/datasets/image_dataset#upload-dataset-<span class="hljs-keyword">to</span>-the-hub), <span class="hljs-keyword">or</span> you can [<span class="hljs-keyword">prepare</span> a <span class="hljs-keyword">local</span> folder <span class="hljs-keyword">with</span> your files](https://huggingface.co/docs/datasets/image_dataset#imagefolder).

Modify the script <span class="hljs-keyword">if</span> you want <span class="hljs-keyword">to</span> use custom loading logic. We left pointers <span class="hljs-keyword">in</span> the code <span class="hljs-keyword">in</span> the appropriate places <span class="hljs-keyword">to</span> help you. \u{1F917} The example script below shows how <span class="hljs-keyword">to</span> finetune <span class="hljs-keyword">on</span> a <span class="hljs-keyword">local</span> dataset <span class="hljs-keyword">in</span> \`TRAIN_DIR\` <span class="hljs-keyword">and</span> <span class="hljs-keyword">where</span> <span class="hljs-keyword">to</span> save the model <span class="hljs-keyword">to</span> <span class="hljs-keyword">in</span> \`OUTPUT_DIR\`:

\`\`\`bash
export MODEL_NAME=&quot;CompVis/stable-diffusion-v1-4&quot;
export TRAIN_DIR=&quot;path_to_your_dataset&quot;
export OUTPUT_DIR=&quot;path_to_save_model&quot;

accelerate launch train_text_to_image.py \\
  <span class="hljs-comment">--pretrained_model_name_or_path=$MODEL_NAME \\</span>
  <span class="hljs-comment">--train_data_dir=$TRAIN_DIR \\</span>
  <span class="hljs-comment">--use_ema \\</span>
  <span class="hljs-comment">--resolution=512 --center_crop --random_flip \\</span>
  <span class="hljs-comment">--train_batch_size=1 \\</span>
  <span class="hljs-comment">--gradient_accumulation_steps=4 \\</span>
  <span class="hljs-comment">--gradient_checkpointing \\</span>
  <span class="hljs-comment">--mixed_precision=&quot;fp16&quot; \\</span>
  <span class="hljs-comment">--max_train_steps=15000 \\</span>
  <span class="hljs-comment">--learning_rate=1e-05 \\</span>
  <span class="hljs-comment">--max_grad_norm=1 \\</span>
  <span class="hljs-comment">--lr_scheduler=&quot;constant&quot; --lr_warmup_steps=0 \\</span>
  <span class="hljs-comment">--output_dir=\${OUTPUT_DIR}</span>`}}),{c(){o=n("p"),c=i("Launch the "),s=n("a"),d=i("PyTorch training script"),j=i(" for a fine-tuning run on the "),q=n("a"),S=i("Pok\xE9mon BLIP captions"),F=i(" dataset like this:"),O=_(),y(T.$$.fragment),I=_(),y(A.$$.fragment),this.h()},l($){o=r($,"P",{});var P=p(o);c=l(P,"Launch the "),s=r(P,"A",{href:!0,rel:!0});var H=p(s);d=l(H,"PyTorch training script"),H.forEach(t),j=l(P," for a fine-tuning run on the "),q=r(P,"A",{href:!0,rel:!0});var X=p(q);S=l(X,"Pok\xE9mon BLIP captions"),X.forEach(t),F=l(P," dataset like this:"),P.forEach(t),O=g($),v(T.$$.fragment,$),I=g($),v(A.$$.fragment,$),this.h()},h(){m(s,"href","https://github.com/huggingface/diffusers/blob/main/examples/text_to_image/train_text_to_image.py"),m(s,"rel","nofollow"),m(q,"href","https://huggingface.co/datasets/lambdalabs/pokemon-blip-captions"),m(q,"rel","nofollow")},m($,P){u($,o,P),a(o,c),a(o,s),a(s,d),a(o,j),a(o,q),a(q,S),a(o,F),u($,O,P),b(T,$,P),u($,I,P),b(A,$,P),D=!0},p:Kt,i($){D||(k(T.$$.fragment,$),k(A.$$.fragment,$),D=!0)},o($){x(T.$$.fragment,$),x(A.$$.fragment,$),D=!1},d($){$&&t(o),$&&t(O),E(T,$),$&&t(I),E(A,$)}}}function Is(N){let o,c;return o=new Xt({props:{$$slots:{default:[Ns]},$$scope:{ctx:N}}}),{c(){y(o.$$.fragment)},l(s){v(o.$$.fragment,s)},m(s,d){b(o,s,d),c=!0},p(s,d){const j={};d&2&&(j.$$scope={dirty:d,ctx:s}),o.$set(j)},i(s){c||(k(o.$$.fragment,s),c=!0)},o(s){x(o.$$.fragment,s),c=!1},d(s){E(o,s)}}}function Ms(N){let o,c,s,d,j,q,S,F,O,T,I,A,D,$,P,H,X,Q,B,U,Te,z,te,De,Y,Z,ue,R,Ne,ee,me,W,ce,G,de,ae,_e,V,L;return T=new K({props:{code:"pip install -U -r requirements_flax.txt",highlighted:"pip install -U -r requirements_flax.txt"}}),Q=new K({props:{code:`export MODEL_NAME="runwayml/stable-diffusion-v1-5"
export dataset_name="lambdalabs/pokemon-blip-captions"

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$dataset_name \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir="sd-pokemon-model" `,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-built_in">export</span> dataset_name=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$dataset_name</span> \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span> `}}),V=new K({props:{code:`export MODEL_NAME="duongna/stable-diffusion-v1-4-flax"
export TRAIN_DIR="path_to_your_dataset"

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --train_data_dir=$TRAIN_DIR \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --mixed_precision="fp16" \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir="sd-pokemon-model"`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;duongna/stable-diffusion-v1-4-flax&quot;</span>
<span class="hljs-built_in">export</span> TRAIN_DIR=<span class="hljs-string">&quot;path_to_your_dataset&quot;</span>

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --train_data_dir=<span class="hljs-variable">$TRAIN_DIR</span> \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span>`}}),{c(){o=n("p"),c=i("With Flax, it\u2019s possible to train a Stable Diffusion model faster on TPUs and GPUs thanks to "),s=n("a"),d=i("@duongna211"),j=i(". This is very efficient on TPU hardware but works great on GPUs too. The Flax training script doesn\u2019t support features like gradient checkpointing or gradient accumulation yet, so you\u2019ll need a GPU with at least 30GB of memory or a TPU v3."),q=_(),S=n("p"),F=i("Before running the script, make sure you have the requirements installed:"),O=_(),y(T.$$.fragment),I=_(),A=n("p"),D=i("Now you can launch the "),$=n("a"),P=i("Flax training script"),H=i(" like this:"),X=_(),y(Q.$$.fragment),B=_(),U=n("p"),Te=i("To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} "),z=n("a"),te=i("Datasets"),De=i(". You can "),Y=n("a"),Z=i("upload your dataset to the Hub"),ue=i(", or you can "),R=n("a"),Ne=i("prepare a local folder with your files"),ee=i("."),me=_(),W=n("p"),ce=i("Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in "),G=n("code"),de=i("TRAIN_DIR"),ae=i(":"),_e=_(),y(V.$$.fragment),this.h()},l(h){o=r(h,"P",{});var w=p(o);c=l(w,"With Flax, it\u2019s possible to train a Stable Diffusion model faster on TPUs and GPUs thanks to "),s=r(w,"A",{href:!0,rel:!0});var se=p(s);d=l(se,"@duongna211"),se.forEach(t),j=l(w,". This is very efficient on TPU hardware but works great on GPUs too. The Flax training script doesn\u2019t support features like gradient checkpointing or gradient accumulation yet, so you\u2019ll need a GPU with at least 30GB of memory or a TPU v3."),w.forEach(t),q=g(h),S=r(h,"P",{});var He=p(S);F=l(He,"Before running the script, make sure you have the requirements installed:"),He.forEach(t),O=g(h),v(T.$$.fragment,h),I=g(h),A=r(h,"P",{});var oe=p(A);D=l(oe,"Now you can launch the "),$=r(oe,"A",{href:!0,rel:!0});var Be=p($);P=l(Be,"Flax training script"),Be.forEach(t),H=l(oe," like this:"),oe.forEach(t),X=g(h),v(Q.$$.fragment,h),B=g(h),U=r(h,"P",{});var C=p(U);Te=l(C,"To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} "),z=r(C,"A",{href:!0,rel:!0});var M=p(z);te=l(M,"Datasets"),M.forEach(t),De=l(C,". You can "),Y=r(C,"A",{href:!0,rel:!0});var ze=p(Y);Z=l(ze,"upload your dataset to the Hub"),ze.forEach(t),ue=l(C,", or you can "),R=r(C,"A",{href:!0,rel:!0});var ge=p(R);Ne=l(ge,"prepare a local folder with your files"),ge.forEach(t),ee=l(C,"."),C.forEach(t),me=g(h),W=r(h,"P",{});var $e=p(W);ce=l($e,"Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in "),G=r($e,"CODE",{});var Ye=p(G);de=l(Ye,"TRAIN_DIR"),Ye.forEach(t),ae=l($e,":"),$e.forEach(t),_e=g(h),v(V.$$.fragment,h),this.h()},h(){m(s,"href","https://github.com/duongna21"),m(s,"rel","nofollow"),m($,"href","https://github.com/huggingface/diffusers/blob/main/examples/text_to_image/train_text_to_image_flax.py"),m($,"rel","nofollow"),m(z,"href","https://huggingface.co/docs/datasets/index"),m(z,"rel","nofollow"),m(Y,"href","https://huggingface.co/docs/datasets/image_dataset#upload-dataset-to-the-hub"),m(Y,"rel","nofollow"),m(R,"href","https://huggingface.co/docs/datasets/image_dataset#imagefolder"),m(R,"rel","nofollow")},m(h,w){u(h,o,w),a(o,c),a(o,s),a(s,d),a(o,j),u(h,q,w),u(h,S,w),a(S,F),u(h,O,w),b(T,h,w),u(h,I,w),u(h,A,w),a(A,D),a(A,$),a($,P),a(A,H),u(h,X,w),b(Q,h,w),u(h,B,w),u(h,U,w),a(U,Te),a(U,z),a(z,te),a(U,De),a(U,Y),a(Y,Z),a(U,ue),a(U,R),a(R,Ne),a(U,ee),u(h,me,w),u(h,W,w),a(W,ce),a(W,G),a(G,de),a(W,ae),u(h,_e,w),b(V,h,w),L=!0},p:Kt,i(h){L||(k(T.$$.fragment,h),k(Q.$$.fragment,h),k(V.$$.fragment,h),L=!0)},o(h){x(T.$$.fragment,h),x(Q.$$.fragment,h),x(V.$$.fragment,h),L=!1},d(h){h&&t(o),h&&t(q),h&&t(S),h&&t(O),E(T,h),h&&t(I),h&&t(A),h&&t(X),E(Q,h),h&&t(B),h&&t(U),h&&t(me),h&&t(W),h&&t(_e),E(V,h)}}}function Us(N){let o,c;return o=new Xt({props:{$$slots:{default:[Ms]},$$scope:{ctx:N}}}),{c(){y(o.$$.fragment)},l(s){v(o.$$.fragment,s)},m(s,d){b(o,s,d),c=!0},p(s,d){const j={};d&2&&(j.$$scope={dirty:d,ctx:s}),o.$set(j)},i(s){c||(k(o.$$.fragment,s),c=!0)},o(s){x(o.$$.fragment,s),c=!1},d(s){E(o,s)}}}function Rs(N){let o,c;return o=new K({props:{code:`from diffusers import StableDiffusionPipeline

model_path = "path_to_saved_model"
pipe = StableDiffusionPipeline.from_pretrained(model_path, torch_dtype=torch.float16)
pipe.to("cuda")

image = pipe(prompt="yoda").images[0]
image.save("yoda-pokemon.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

model_path = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_path, torch_dtype=torch.float16)
pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

image = pipe(prompt=<span class="hljs-string">&quot;yoda&quot;</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;yoda-pokemon.png&quot;</span>)`}}),{c(){y(o.$$.fragment)},l(s){v(o.$$.fragment,s)},m(s,d){b(o,s,d),c=!0},p:Kt,i(s){c||(k(o.$$.fragment,s),c=!0)},o(s){x(o.$$.fragment,s),c=!1},d(s){E(o,s)}}}function Ss(N){let o,c;return o=new Xt({props:{$$slots:{default:[Rs]},$$scope:{ctx:N}}}),{c(){y(o.$$.fragment)},l(s){v(o.$$.fragment,s)},m(s,d){b(o,s,d),c=!0},p(s,d){const j={};d&2&&(j.$$scope={dirty:d,ctx:s}),o.$set(j)},i(s){c||(k(o.$$.fragment,s),c=!0)},o(s){x(o.$$.fragment,s),c=!1},d(s){E(o,s)}}}function Ls(N){let o,c;return o=new K({props:{code:`import jax
import numpy as np
from flax.jax_utils import replicate
from flax.training.common_utils import shard
from diffusers import FlaxStableDiffusionPipeline

model_path = "path_to_saved_model"
pipe, params = FlaxStableDiffusionPipeline.from_pretrained(model_path, dtype=jax.numpy.bfloat16)

prompt = "yoda pokemon"
prng_seed = jax.random.PRNGKey(0)
num_inference_steps = 50

num_samples = jax.device_count()
prompt = num_samples * [prompt]
prompt_ids = pipeline.prepare_inputs(prompt)

# shard inputs and rng
params = replicate(params)
prng_seed = jax.random.split(prng_seed, jax.device_count())
prompt_ids = shard(prompt_ids)

images = pipeline(prompt_ids, params, prng_seed, num_inference_steps, jit=True).images
images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-3:])))
image.save("yoda-pokemon.png")`,highlighted:`<span class="hljs-keyword">import</span> jax
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionPipeline

model_path = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe, params = FlaxStableDiffusionPipeline.from_pretrained(model_path, dtype=jax.numpy.bfloat16)

prompt = <span class="hljs-string">&quot;yoda pokemon&quot;</span>
prng_seed = jax.random.PRNGKey(<span class="hljs-number">0</span>)
num_inference_steps = <span class="hljs-number">50</span>

num_samples = jax.device_count()
prompt = num_samples * [prompt]
prompt_ids = pipeline.prepare_inputs(prompt)

<span class="hljs-comment"># shard inputs and rng</span>
params = replicate(params)
prng_seed = jax.random.split(prng_seed, jax.device_count())
prompt_ids = shard(prompt_ids)

images = pipeline(prompt_ids, params, prng_seed, num_inference_steps, jit=<span class="hljs-literal">True</span>).images
images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-<span class="hljs-number">3</span>:])))
image.save(<span class="hljs-string">&quot;yoda-pokemon.png&quot;</span>)`}}),{c(){y(o.$$.fragment)},l(s){v(o.$$.fragment,s)},m(s,d){b(o,s,d),c=!0},p:Kt,i(s){c||(k(o.$$.fragment,s),c=!0)},o(s){x(o.$$.fragment,s),c=!1},d(s){E(o,s)}}}function Fs(N){let o,c;return o=new Xt({props:{$$slots:{default:[Ls]},$$scope:{ctx:N}}}),{c(){y(o.$$.fragment)},l(s){v(o.$$.fragment,s)},m(s,d){b(o,s,d),c=!0},p(s,d){const j={};d&2&&(j.$$scope={dirty:d,ctx:s}),o.$set(j)},i(s){c||(k(o.$$.fragment,s),c=!0)},o(s){x(o.$$.fragment,s),c=!1},d(s){E(o,s)}}}function Os(N){let o,c,s,d,j,q,S,F,O,T,I,A,D,$,P,H,X,Q,B,U,Te,z,te,De,Y,Z,ue,R,Ne,ee,me,W,ce,G,de,ae,_e,V,L,h,w,se,He,oe,Be,C,M,ze,ge,$e,Ye,at,Qt,Zt,st,ea,ta,We,aa,sa,vt,ne,oa,Ve,na,ra,ot,ia,la,bt,Je,pa,kt,ie,we,nt,Ie,fa,rt,ha,xt,Ke,ua,Et,Me,jt,le,ye,it,Ue,ma,lt,ca,Pt,Xe,da,At,Re,qt,J,_a,pt,ga,$a,ft,wa,ya,ht,va,ba,Tt,ve,ka,ut,xa,Ea,Dt,Se,Nt,pe,be,mt,Le,ja,ct,Pa,It,ke,Mt,fe,xe,dt,Fe,Aa,_t,qa,Ut,Ee,Ta,Qe,Da,Na,Rt,he,je,gt,Oe,Ia,$t,Ma,St,Pe,Ua,Ze,Ra,Sa,Lt,Ae,Ft;return q=new Ce({}),I=new Ts({props:{warning:!0,$$slots:{default:[Ds]},$$scope:{ctx:N}}}),Z=new K({props:{code:`pip install git+https://github.com/huggingface/diffusers.git
pip install -U -r requirements.txt`,highlighted:`pip install git+https://github.com/huggingface/diffusers.git
pip install -U -r requirements.txt`}}),G=new K({props:{code:"accelerate config",highlighted:"accelerate config"}}),se=new Ce({}),Ie=new Ce({}),Me=new K({props:{code:"  --push_to_hub",highlighted:"  --push_to_hub"}}),Ue=new Ce({}),Re=new K({props:{code:"  --checkpointing_steps=500",highlighted:"  --checkpointing_steps=500"}}),Se=new K({props:{code:'  --resume_from_checkpoint="checkpoint-1500"',highlighted:'  --resume_from_checkpoint=<span class="hljs-string">&quot;checkpoint-1500&quot;</span>'}}),Le=new Ce({}),ke=new xs({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[Us],pytorch:[Is]},$$scope:{ctx:N}}}),Fe=new Ce({}),Oe=new Ce({}),Ae=new xs({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[Fs],pytorch:[Ss]},$$scope:{ctx:N}}}),{c(){o=n("meta"),c=_(),s=n("h1"),d=n("a"),j=n("span"),y(q.$$.fragment),S=_(),F=n("span"),O=i("Text-to-image"),T=_(),y(I.$$.fragment),A=_(),D=n("p"),$=i("Text-to-image models like Stable Diffusion generate an image from a text prompt. This guide will show you how to finetune the "),P=n("a"),H=n("code"),X=i("CompVis/stable-diffusion-v1-4"),Q=i(" model on your own dataset with PyTorch and Flax. All the training scripts for text-to-image finetuning used in this guide can be found in this "),B=n("a"),U=i("repository"),Te=i(" if you\u2019re interested in taking a closer look."),z=_(),te=n("p"),De=i("Before running the scripts, make sure to install the library\u2019s training dependencies:"),Y=_(),y(Z.$$.fragment),ue=_(),R=n("p"),Ne=i("And initialize an "),ee=n("a"),me=i("\u{1F917} Accelerate"),W=i(" environment with:"),ce=_(),y(G.$$.fragment),de=_(),ae=n("p"),_e=i("If you have already cloned the repo, then you won\u2019t need to go through these steps. Instead, you can pass the path to your local checkout to the training script and it will be loaded from there."),V=_(),L=n("h2"),h=n("a"),w=n("span"),y(se.$$.fragment),He=_(),oe=n("span"),Be=i("Hardware requirements"),C=_(),M=n("p"),ze=i("Using "),ge=n("code"),$e=i("gradient_checkpointing"),Ye=i(" and "),at=n("code"),Qt=i("mixed_precision"),Zt=i(", it should be possible to finetune the model on a single 24GB GPU. For higher "),st=n("code"),ea=i("batch_size"),ta=i("\u2019s and faster training, it\u2019s better to use GPUs with more than 30GB of GPU memory. You can also use JAX/Flax for fine-tuning on TPUs or GPUs, which will be covered "),We=n("a"),aa=i("below"),sa=i("."),vt=_(),ne=n("p"),oa=i("You can reduce your memory footprint even more by enabling memory efficient attention with xFormers. Make sure you have "),Ve=n("a"),na=i("xFormers installed"),ra=i(" and pass the "),ot=n("code"),ia=i("--enable_xformers_memory_efficient_attention"),la=i(" flag to the training script."),bt=_(),Je=n("p"),pa=i("xFormers is not available for Flax."),kt=_(),ie=n("h2"),we=n("a"),nt=n("span"),y(Ie.$$.fragment),fa=_(),rt=n("span"),ha=i("Upload model to Hub"),xt=_(),Ke=n("p"),ua=i("Store your model on the Hub by adding the following argument to the training script:"),Et=_(),y(Me.$$.fragment),jt=_(),le=n("h2"),ye=n("a"),it=n("span"),y(Ue.$$.fragment),ma=_(),lt=n("span"),ca=i("Save and load checkpoints"),Pt=_(),Xe=n("p"),da=i("It is a good idea to regularly save checkpoints in case anything happens during training. To save a checkpoint, pass the following argument to the training script:"),At=_(),y(Re.$$.fragment),qt=_(),J=n("p"),_a=i("Every 500 steps, the full training state is saved in a subfolder in the "),pt=n("code"),ga=i("output_dir"),$a=i(". The checkpoint has the format "),ft=n("code"),wa=i("checkpoint-"),ya=i(" followed by the number of steps trained so far. For example, "),ht=n("code"),va=i("checkpoint-1500"),ba=i(" is a checkpoint saved after 1500 training steps."),Tt=_(),ve=n("p"),ka=i("To load a checkpoint to resume training, pass the argument "),ut=n("code"),xa=i("--resume_from_checkpoint"),Ea=i(" to the training script and specify the checkpoint you want to resume from. For example, the following argument resumes training from the checkpoint saved after 1500 training steps:"),Dt=_(),y(Se.$$.fragment),Nt=_(),pe=n("h2"),be=n("a"),mt=n("span"),y(Le.$$.fragment),ja=_(),ct=n("span"),Pa=i("Fine-tuning"),It=_(),y(ke.$$.fragment),Mt=_(),fe=n("h2"),xe=n("a"),dt=n("span"),y(Fe.$$.fragment),Aa=_(),_t=n("span"),qa=i("LoRA"),Ut=_(),Ee=n("p"),Ta=i("You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, for fine-tuning text-to-image models. For more details, take a look at the "),Qe=n("a"),Da=i("LoRA training"),Na=i(" guide."),Rt=_(),he=n("h2"),je=n("a"),gt=n("span"),y(Oe.$$.fragment),Ia=_(),$t=n("span"),Ma=i("Inference"),St=_(),Pe=n("p"),Ua=i("Now you can load the fine-tuned model for inference by passing the model path or model name on the Hub to the "),Ze=n("a"),Ra=i("StableDiffusionPipeline"),Sa=i(":"),Lt=_(),y(Ae.$$.fragment),this.h()},l(e){const f=As('[data-svelte="svelte-1phssyn"]',document.head);o=r(f,"META",{name:!0,content:!0}),f.forEach(t),c=g(e),s=r(e,"H1",{class:!0});var Ge=p(s);d=r(Ge,"A",{id:!0,class:!0,href:!0});var wt=p(d);j=r(wt,"SPAN",{});var yt=p(j);v(q.$$.fragment,yt),yt.forEach(t),wt.forEach(t),S=g(Ge),F=r(Ge,"SPAN",{});var La=p(F);O=l(La,"Text-to-image"),La.forEach(t),Ge.forEach(t),T=g(e),v(I.$$.fragment,e),A=g(e),D=r(e,"P",{});var et=p(D);$=l(et,"Text-to-image models like Stable Diffusion generate an image from a text prompt. This guide will show you how to finetune the "),P=r(et,"A",{href:!0,rel:!0});var Fa=p(P);H=r(Fa,"CODE",{});var Oa=p(H);X=l(Oa,"CompVis/stable-diffusion-v1-4"),Oa.forEach(t),Fa.forEach(t),Q=l(et," model on your own dataset with PyTorch and Flax. All the training scripts for text-to-image finetuning used in this guide can be found in this "),B=r(et,"A",{href:!0,rel:!0});var Ga=p(B);U=l(Ga,"repository"),Ga.forEach(t),Te=l(et," if you\u2019re interested in taking a closer look."),et.forEach(t),z=g(e),te=r(e,"P",{});var Ca=p(te);De=l(Ca,"Before running the scripts, make sure to install the library\u2019s training dependencies:"),Ca.forEach(t),Y=g(e),v(Z.$$.fragment,e),ue=g(e),R=r(e,"P",{});var Ot=p(R);Ne=l(Ot,"And initialize an "),ee=r(Ot,"A",{href:!0,rel:!0});var Ha=p(ee);me=l(Ha,"\u{1F917} Accelerate"),Ha.forEach(t),W=l(Ot," environment with:"),Ot.forEach(t),ce=g(e),v(G.$$.fragment,e),de=g(e),ae=r(e,"P",{});var Ba=p(ae);_e=l(Ba,"If you have already cloned the repo, then you won\u2019t need to go through these steps. Instead, you can pass the path to your local checkout to the training script and it will be loaded from there."),Ba.forEach(t),V=g(e),L=r(e,"H2",{class:!0});var Gt=p(L);h=r(Gt,"A",{id:!0,class:!0,href:!0});var za=p(h);w=r(za,"SPAN",{});var Ya=p(w);v(se.$$.fragment,Ya),Ya.forEach(t),za.forEach(t),He=g(Gt),oe=r(Gt,"SPAN",{});var Wa=p(oe);Be=l(Wa,"Hardware requirements"),Wa.forEach(t),Gt.forEach(t),C=g(e),M=r(e,"P",{});var re=p(M);ze=l(re,"Using "),ge=r(re,"CODE",{});var Va=p(ge);$e=l(Va,"gradient_checkpointing"),Va.forEach(t),Ye=l(re," and "),at=r(re,"CODE",{});var Ja=p(at);Qt=l(Ja,"mixed_precision"),Ja.forEach(t),Zt=l(re,", it should be possible to finetune the model on a single 24GB GPU. For higher "),st=r(re,"CODE",{});var Ka=p(st);ea=l(Ka,"batch_size"),Ka.forEach(t),ta=l(re,"\u2019s and faster training, it\u2019s better to use GPUs with more than 30GB of GPU memory. You can also use JAX/Flax for fine-tuning on TPUs or GPUs, which will be covered "),We=r(re,"A",{href:!0});var Xa=p(We);aa=l(Xa,"below"),Xa.forEach(t),sa=l(re,"."),re.forEach(t),vt=g(e),ne=r(e,"P",{});var tt=p(ne);oa=l(tt,"You can reduce your memory footprint even more by enabling memory efficient attention with xFormers. Make sure you have "),Ve=r(tt,"A",{href:!0});var Qa=p(Ve);na=l(Qa,"xFormers installed"),Qa.forEach(t),ra=l(tt," and pass the "),ot=r(tt,"CODE",{});var Za=p(ot);ia=l(Za,"--enable_xformers_memory_efficient_attention"),Za.forEach(t),la=l(tt," flag to the training script."),tt.forEach(t),bt=g(e),Je=r(e,"P",{});var es=p(Je);pa=l(es,"xFormers is not available for Flax."),es.forEach(t),kt=g(e),ie=r(e,"H2",{class:!0});var Ct=p(ie);we=r(Ct,"A",{id:!0,class:!0,href:!0});var ts=p(we);nt=r(ts,"SPAN",{});var as=p(nt);v(Ie.$$.fragment,as),as.forEach(t),ts.forEach(t),fa=g(Ct),rt=r(Ct,"SPAN",{});var ss=p(rt);ha=l(ss,"Upload model to Hub"),ss.forEach(t),Ct.forEach(t),xt=g(e),Ke=r(e,"P",{});var os=p(Ke);ua=l(os,"Store your model on the Hub by adding the following argument to the training script:"),os.forEach(t),Et=g(e),v(Me.$$.fragment,e),jt=g(e),le=r(e,"H2",{class:!0});var Ht=p(le);ye=r(Ht,"A",{id:!0,class:!0,href:!0});var ns=p(ye);it=r(ns,"SPAN",{});var rs=p(it);v(Ue.$$.fragment,rs),rs.forEach(t),ns.forEach(t),ma=g(Ht),lt=r(Ht,"SPAN",{});var is=p(lt);ca=l(is,"Save and load checkpoints"),is.forEach(t),Ht.forEach(t),Pt=g(e),Xe=r(e,"P",{});var ls=p(Xe);da=l(ls,"It is a good idea to regularly save checkpoints in case anything happens during training. To save a checkpoint, pass the following argument to the training script:"),ls.forEach(t),At=g(e),v(Re.$$.fragment,e),qt=g(e),J=r(e,"P",{});var qe=p(J);_a=l(qe,"Every 500 steps, the full training state is saved in a subfolder in the "),pt=r(qe,"CODE",{});var ps=p(pt);ga=l(ps,"output_dir"),ps.forEach(t),$a=l(qe,". The checkpoint has the format "),ft=r(qe,"CODE",{});var fs=p(ft);wa=l(fs,"checkpoint-"),fs.forEach(t),ya=l(qe," followed by the number of steps trained so far. For example, "),ht=r(qe,"CODE",{});var hs=p(ht);va=l(hs,"checkpoint-1500"),hs.forEach(t),ba=l(qe," is a checkpoint saved after 1500 training steps."),qe.forEach(t),Tt=g(e),ve=r(e,"P",{});var Bt=p(ve);ka=l(Bt,"To load a checkpoint to resume training, pass the argument "),ut=r(Bt,"CODE",{});var us=p(ut);xa=l(us,"--resume_from_checkpoint"),us.forEach(t),Ea=l(Bt," to the training script and specify the checkpoint you want to resume from. For example, the following argument resumes training from the checkpoint saved after 1500 training steps:"),Bt.forEach(t),Dt=g(e),v(Se.$$.fragment,e),Nt=g(e),pe=r(e,"H2",{class:!0});var zt=p(pe);be=r(zt,"A",{id:!0,class:!0,href:!0});var ms=p(be);mt=r(ms,"SPAN",{});var cs=p(mt);v(Le.$$.fragment,cs),cs.forEach(t),ms.forEach(t),ja=g(zt),ct=r(zt,"SPAN",{});var ds=p(ct);Pa=l(ds,"Fine-tuning"),ds.forEach(t),zt.forEach(t),It=g(e),v(ke.$$.fragment,e),Mt=g(e),fe=r(e,"H2",{class:!0});var Yt=p(fe);xe=r(Yt,"A",{id:!0,class:!0,href:!0});var _s=p(xe);dt=r(_s,"SPAN",{});var gs=p(dt);v(Fe.$$.fragment,gs),gs.forEach(t),_s.forEach(t),Aa=g(Yt),_t=r(Yt,"SPAN",{});var $s=p(_t);qa=l($s,"LoRA"),$s.forEach(t),Yt.forEach(t),Ut=g(e),Ee=r(e,"P",{});var Wt=p(Ee);Ta=l(Wt,"You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, for fine-tuning text-to-image models. For more details, take a look at the "),Qe=r(Wt,"A",{href:!0});var ws=p(Qe);Da=l(ws,"LoRA training"),ws.forEach(t),Na=l(Wt," guide."),Wt.forEach(t),Rt=g(e),he=r(e,"H2",{class:!0});var Vt=p(he);je=r(Vt,"A",{id:!0,class:!0,href:!0});var ys=p(je);gt=r(ys,"SPAN",{});var vs=p(gt);v(Oe.$$.fragment,vs),vs.forEach(t),ys.forEach(t),Ia=g(Vt),$t=r(Vt,"SPAN",{});var bs=p($t);Ma=l(bs,"Inference"),bs.forEach(t),Vt.forEach(t),St=g(e),Pe=r(e,"P",{});var Jt=p(Pe);Ua=l(Jt,"Now you can load the fine-tuned model for inference by passing the model path or model name on the Hub to the "),Ze=r(Jt,"A",{href:!0});var ks=p(Ze);Ra=l(ks,"StableDiffusionPipeline"),ks.forEach(t),Sa=l(Jt,":"),Jt.forEach(t),Lt=g(e),v(Ae.$$.fragment,e),this.h()},h(){m(o,"name","hf:doc:metadata"),m(o,"content",JSON.stringify(Gs)),m(d,"id","texttoimage"),m(d,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(d,"href","#texttoimage"),m(s,"class","relative group"),m(P,"href","https://huggingface.co/CompVis/stable-diffusion-v1-4"),m(P,"rel","nofollow"),m(B,"href","https://github.com/huggingface/diffusers/tree/main/examples/text_to_image"),m(B,"rel","nofollow"),m(ee,"href","https://github.com/huggingface/accelerate/"),m(ee,"rel","nofollow"),m(h,"id","hardware-requirements"),m(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(h,"href","#hardware-requirements"),m(L,"class","relative group"),m(We,"href","#flax-jax-finetuning"),m(Ve,"href","./optimization/xformers"),m(we,"id","upload-model-to-hub"),m(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(we,"href","#upload-model-to-hub"),m(ie,"class","relative group"),m(ye,"id","save-and-load-checkpoints"),m(ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ye,"href","#save-and-load-checkpoints"),m(le,"class","relative group"),m(be,"id","finetuning"),m(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(be,"href","#finetuning"),m(pe,"class","relative group"),m(xe,"id","lora"),m(xe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(xe,"href","#lora"),m(fe,"class","relative group"),m(Qe,"href","lora#text-to-image"),m(je,"id","inference"),m(je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(je,"href","#inference"),m(he,"class","relative group"),m(Ze,"href","/docs/diffusers/pr_2451/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline")},m(e,f){a(document.head,o),u(e,c,f),u(e,s,f),a(s,d),a(d,j),b(q,j,null),a(s,S),a(s,F),a(F,O),u(e,T,f),b(I,e,f),u(e,A,f),u(e,D,f),a(D,$),a(D,P),a(P,H),a(H,X),a(D,Q),a(D,B),a(B,U),a(D,Te),u(e,z,f),u(e,te,f),a(te,De),u(e,Y,f),b(Z,e,f),u(e,ue,f),u(e,R,f),a(R,Ne),a(R,ee),a(ee,me),a(R,W),u(e,ce,f),b(G,e,f),u(e,de,f),u(e,ae,f),a(ae,_e),u(e,V,f),u(e,L,f),a(L,h),a(h,w),b(se,w,null),a(L,He),a(L,oe),a(oe,Be),u(e,C,f),u(e,M,f),a(M,ze),a(M,ge),a(ge,$e),a(M,Ye),a(M,at),a(at,Qt),a(M,Zt),a(M,st),a(st,ea),a(M,ta),a(M,We),a(We,aa),a(M,sa),u(e,vt,f),u(e,ne,f),a(ne,oa),a(ne,Ve),a(Ve,na),a(ne,ra),a(ne,ot),a(ot,ia),a(ne,la),u(e,bt,f),u(e,Je,f),a(Je,pa),u(e,kt,f),u(e,ie,f),a(ie,we),a(we,nt),b(Ie,nt,null),a(ie,fa),a(ie,rt),a(rt,ha),u(e,xt,f),u(e,Ke,f),a(Ke,ua),u(e,Et,f),b(Me,e,f),u(e,jt,f),u(e,le,f),a(le,ye),a(ye,it),b(Ue,it,null),a(le,ma),a(le,lt),a(lt,ca),u(e,Pt,f),u(e,Xe,f),a(Xe,da),u(e,At,f),b(Re,e,f),u(e,qt,f),u(e,J,f),a(J,_a),a(J,pt),a(pt,ga),a(J,$a),a(J,ft),a(ft,wa),a(J,ya),a(J,ht),a(ht,va),a(J,ba),u(e,Tt,f),u(e,ve,f),a(ve,ka),a(ve,ut),a(ut,xa),a(ve,Ea),u(e,Dt,f),b(Se,e,f),u(e,Nt,f),u(e,pe,f),a(pe,be),a(be,mt),b(Le,mt,null),a(pe,ja),a(pe,ct),a(ct,Pa),u(e,It,f),b(ke,e,f),u(e,Mt,f),u(e,fe,f),a(fe,xe),a(xe,dt),b(Fe,dt,null),a(fe,Aa),a(fe,_t),a(_t,qa),u(e,Ut,f),u(e,Ee,f),a(Ee,Ta),a(Ee,Qe),a(Qe,Da),a(Ee,Na),u(e,Rt,f),u(e,he,f),a(he,je),a(je,gt),b(Oe,gt,null),a(he,Ia),a(he,$t),a($t,Ma),u(e,St,f),u(e,Pe,f),a(Pe,Ua),a(Pe,Ze),a(Ze,Ra),a(Pe,Sa),u(e,Lt,f),b(Ae,e,f),Ft=!0},p(e,[f]){const Ge={};f&2&&(Ge.$$scope={dirty:f,ctx:e}),I.$set(Ge);const wt={};f&2&&(wt.$$scope={dirty:f,ctx:e}),ke.$set(wt);const yt={};f&2&&(yt.$$scope={dirty:f,ctx:e}),Ae.$set(yt)},i(e){Ft||(k(q.$$.fragment,e),k(I.$$.fragment,e),k(Z.$$.fragment,e),k(G.$$.fragment,e),k(se.$$.fragment,e),k(Ie.$$.fragment,e),k(Me.$$.fragment,e),k(Ue.$$.fragment,e),k(Re.$$.fragment,e),k(Se.$$.fragment,e),k(Le.$$.fragment,e),k(ke.$$.fragment,e),k(Fe.$$.fragment,e),k(Oe.$$.fragment,e),k(Ae.$$.fragment,e),Ft=!0)},o(e){x(q.$$.fragment,e),x(I.$$.fragment,e),x(Z.$$.fragment,e),x(G.$$.fragment,e),x(se.$$.fragment,e),x(Ie.$$.fragment,e),x(Me.$$.fragment,e),x(Ue.$$.fragment,e),x(Re.$$.fragment,e),x(Se.$$.fragment,e),x(Le.$$.fragment,e),x(ke.$$.fragment,e),x(Fe.$$.fragment,e),x(Oe.$$.fragment,e),x(Ae.$$.fragment,e),Ft=!1},d(e){t(o),e&&t(c),e&&t(s),E(q),e&&t(T),E(I,e),e&&t(A),e&&t(D),e&&t(z),e&&t(te),e&&t(Y),E(Z,e),e&&t(ue),e&&t(R),e&&t(ce),E(G,e),e&&t(de),e&&t(ae),e&&t(V),e&&t(L),E(se),e&&t(C),e&&t(M),e&&t(vt),e&&t(ne),e&&t(bt),e&&t(Je),e&&t(kt),e&&t(ie),E(Ie),e&&t(xt),e&&t(Ke),e&&t(Et),E(Me,e),e&&t(jt),e&&t(le),E(Ue),e&&t(Pt),e&&t(Xe),e&&t(At),E(Re,e),e&&t(qt),e&&t(J),e&&t(Tt),e&&t(ve),e&&t(Dt),E(Se,e),e&&t(Nt),e&&t(pe),E(Le),e&&t(It),E(ke,e),e&&t(Mt),e&&t(fe),E(Fe),e&&t(Ut),e&&t(Ee),e&&t(Rt),e&&t(he),E(Oe),e&&t(St),e&&t(Pe),e&&t(Lt),E(Ae,e)}}}const Gs={local:"texttoimage",sections:[{local:"hardware-requirements",title:"Hardware requirements"},{local:"upload-model-to-hub",title:"Upload model to Hub"},{local:"save-and-load-checkpoints",title:"Save and load checkpoints"},{local:"finetuning",title:"Fine-tuning"},{local:"lora",title:"LoRA"},{local:"inference",title:"Inference"}],title:"Text-to-image"};function Cs(N){return qs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Vs extends Es{constructor(o){super();js(this,o,Cs,Os,Ps,{})}}export{Vs as default,Gs as metadata};
